package com.ipsa.learn.config;

import com.github.xiaoymin.swaggerbootstrapui.annotations.EnableSwaggerBootstrapUI;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import springfox.documentation.builders.ApiInfoBuilder;
import springfox.documentation.builders.PathSelectors;
import springfox.documentation.builders.RequestHandlerSelectors;
import springfox.documentation.service.ApiInfo;
import springfox.documentation.spi.DocumentationType;
import springfox.documentation.spring.web.plugins.Docket;
import springfox.documentation.swagger2.annotations.EnableSwagger2;

@Configuration
@EnableSwagger2
@EnableSwaggerBootstrapUI
public class SwaggerConfig {

    @Bean
    public Docket createRestApi() {
        return new Docket(DocumentationType.SWAGGER_2)
                .apiInfo(apiInfo())
                .select()
                .apis(RequestHandlerSelectors.basePackage("com.ipsa.learn"))
                .paths(PathSelectors.any())
                .build();
//.enable(false) 项目上线时可以关掉swagger 文档
    }



    private ApiInfo apiInfo() {
        return new ApiInfoBuilder()
                .title("钉钉校园在线文档")
                .description("create by liyuanxin")
                .termsOfServiceUrl("http://localhost:8080")
                .version("1.0")
                .build();
    }

}