package com.ipsa.learn.controller;


import com.dingtalk.api.DefaultDingTalkClient;
import com.dingtalk.api.DingTalkClient;
import com.dingtalk.api.request.OapiMessageSendToConversationRequest;
import com.dingtalk.api.response.OapiMessageCorpconversationAsyncsendV2Response;
import com.dingtalk.api.response.OapiMessageSendToConversationResponse;
import com.ipsa.learn.entity.*;
import com.ipsa.learn.service.CourseResultsuploadService;
import com.ipsa.learn.util.ResponseModel;
import com.ipsa.learn.util.ResultCode;
import com.ipsa.learn.util.dingtalkUtil.CssDingUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import org.springframework.stereotype.Controller;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * 考试上传 前端控制器
 * </p>
 *
 * @author 1079626511@qq.com
 * @since 2020-09-03
 */
@Slf4j
@RestController
@Api(tags = "考试上传")
@RequestMapping("/courseResultsupload")
public class CourseResultsuploadController {

    @Autowired
    CourseResultsuploadService courseResultsuploadService;

    /**
     * 查询考试名称
     * @param courseResultsupload
     * @return
     */
    @PostMapping("/getTestNameList")
    @ApiOperation("查询考试名称")
    public ResponseModel<List<String>> getTestNameList(@RequestBody CourseResultsupload courseResultsupload){
        try {
            log.info("*******scheduleDto******* :{}",courseResultsupload.toString());
            List<String> testNameList = courseResultsuploadService.getTestNameList(courseResultsupload);
            return ResponseModel.success(testNameList).code(ResultCode.SUCCESS);
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseModel.failure("查询科目失败").code(ResultCode.ERROR);
        }
    }

    @ApiOperation("成绩发布列表")
    @PostMapping("/resultsPublishList")
    public ResponseModel<List<CourseResultsupload>> getResultsPublishList(
            @RequestBody CourseResultsuploadDto courseResultsuploadDto) {

        log.info("成绩发布列表查询,请求参数={}", courseResultsuploadDto);
        try {
            return ResponseModel.success(courseResultsuploadService
                    .getResultsPublishList(courseResultsuploadDto)).code(ResultCode.SUCCESS);
        } catch (Exception e) {
            log.info("成绩发布列表查询失败", e);
            return ResponseModel.failure("成绩发布列表查询失败").code(ResultCode.ERROR);
        }
    }

    @ApiOperation("修改成绩发布状态")
    @PostMapping("/updateResultsPublishStatus")
    public ResponseModel<Map<String, Object>> updateResultsPublishStatus(
            @RequestParam(name = "courseResultsuploadId")Integer courseResultsuploadId) {

        log.info("修改成绩发布状态,请求参数={}", courseResultsuploadId);
        return ResponseModel.success(courseResultsuploadService
                .updateResultsPublishStatus(Long.valueOf(courseResultsuploadId))).code(ResultCode.SUCCESS);
    }

    @ApiOperation("成绩分享到班级群")
    @PostMapping(value = "/resultsShare", produces = "application/json;charset=utf-8")
    public OapiMessageCorpconversationAsyncsendV2Response resultsShare(
            @RequestBody SessionReqDto sessionReqDto) {
        String title = "成绩单";
        String singleTitle = "查看详情";
        String singleUrl = "eapp://pages/applyList/applyList";

        String testDateName = "[成绩单]" + sessionReqDto.getTestDateName();
        String markDown = "## " + testDateName + " \n 请尽快查看" + sessionReqDto.getTestDateName() + "成绩";
        //return CssDingUtil.sendNewActionCardMsg(sessionReqDto.getSender(), sessionReqDto.getCid(), title, singleTitle, singleUrl, markDown);
        return CssDingUtil.sendActionCardMsg(sessionReqDto.getSender(), title, singleTitle, singleUrl, markDown);
    }

}

