package com.ipsa.learn.controller;


import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ipsa.learn.entity.CrsPOrderForm;
import com.ipsa.learn.entity.ElectiveCourse;
import com.ipsa.learn.entity.ElectiveEnroll;
import com.ipsa.learn.service.CrsPOrderFormService;
import com.ipsa.learn.service.ElectiveCourseService;
import com.ipsa.learn.util.ChooseStatus;
import com.ipsa.learn.util.DateUtil;
import com.ipsa.learn.util.ResponseModel;
import com.ipsa.learn.util.ResultCode;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;


/**
 * <p>
 * 选修课排课 前端控制器
 * </p>
 *
 * @author 1079626511@qq.com
 * @since 2020-08-24
 */
@Slf4j
@Api(tags = "选修课排课")
@RestController
@RequestMapping("/electiveCourse")
public class ElectiveCourseController {

    @Autowired
    ElectiveCourseService electiveCourseService;

    @Autowired
    CrsPOrderFormService crsPOrderFormService;


    //添加排课表
    @ApiOperation("老师添加选修课排课表")
    @PostMapping("/save")
    public ResponseModel<String> save(@RequestBody ElectiveCourse electiveCourse){
        try {
            log.info("****electiveCourse****,:{}",electiveCourse.toString());
            electiveCourse.setYn(ChooseStatus.NORMAL.getValue());
            electiveCourse.setEnrollNumber(0);
            electiveCourseService.save(electiveCourse);
            return ResponseModel.success("添加选修排课列表成功").code(ResultCode.SUCCESS);
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseModel.failure("添加选修排课列表失败").code(ResultCode.ERROR);
        }
    }

    /**
     * 查看排课列表
     * @param electiveCourse
     * @return
     */
    @ApiOperation("查看选修课排课列表")
    @PostMapping("/getelcourse")
    public ResponseModel<List<ElectiveCourse>> getElectiveCourseList(@RequestBody ElectiveCourse electiveCourse){
        log.info("******schoolCode**** ,:{}",electiveCourse.toString());
        try {
            LambdaQueryWrapper<ElectiveCourse> queryWrapper = new LambdaQueryWrapper<>();
            queryWrapper.eq(ElectiveCourse::getSchoolCode,electiveCourse.getSchoolCode());
            queryWrapper.eq(ElectiveCourse::getSchoolYear,electiveCourse.getSchoolYear());
            queryWrapper.eq(ElectiveCourse::getSemester,electiveCourse.getSemester());
            queryWrapper.eq(ElectiveCourse::getYn,ChooseStatus.NORMAL.getValue());
            List<ElectiveCourse> list = electiveCourseService.list(queryWrapper);
            log.info("******List<ElectiveCourse>****, :{}",list.toString());
            return ResponseModel.success(list).code(ResultCode.SUCCESS);
        } catch (Exception e) {
            e.printStackTrace();
            return ResponseModel.failure("查询排课列表失败").code(ResultCode.ERROR);
        }
    }

}

