package com.ipsa.learn.controller;

import com.ipsa.learn.entity.LearnAnalysisRequest;
import com.ipsa.learn.entity.LearnAnalysisRespone;
import com.ipsa.learn.service.CourseResultlistService;
import com.ipsa.learn.util.ResponseModel;
import com.ipsa.learn.util.ResultCode;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @program: LearnAnalysisController
 * @description: 学情分析
 * @author: llq
 * @date: 2020/9/8
 */
@Slf4j
@RestController
@Api(tags = "学情分析")
@RequestMapping("learnAnalysis")
public class LearnAnalysisController {

    @Autowired
    private CourseResultlistService resultlistService;

    @ApiOperation("学情分析列表")
    @PostMapping("/list")
    public ResponseModel<LearnAnalysisRespone> list(@RequestBody LearnAnalysisRequest request) {
        log.info("*********学情分析请求参数*******, :{}", request);
        try {
            LearnAnalysisRespone response = resultlistService.getLearnAnalysis(request);


            return ResponseModel.success(response).code(ResultCode.SUCCESS);
        } catch (Exception ex) {
            ex.printStackTrace();
            log.error("查询学情分析失败={}", ex);
            return ResponseModel.failure("查询学情分析失败").code(ResultCode.ERROR);
        }
    }
}

