package com.ipsa.learn.dao;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.ipsa.learn.entity.*;

import java.util.List;
import java.util.Map;


public interface CommentByStudentDao extends BaseMapper<CommentByStudent> {

    List<StudentTotalScore> getScoreSortingList(RankByClass rankByClass);

    /**
     * 获取学生平均及最高分
     * @param studentScoreDto
     * @return
     */
    StudentScoreDetails getStudentScoreDetails(StudentScoreDto studentScoreDto);

    /**
     * 获取班级排名及分数情况
     * @param studentScoreDto
     * @return
     */
    StudentScoreDetails getStudentScoreRankByClass(StudentScoreDto studentScoreDto);

    /**
     * 获取一次学生班级排名
     * @param studentScoreDto
     * @return
     */
    StudentScoreDetails getStudentScoreRankByClassOne(StudentScoreDto studentScoreDto);

    /**
     * 获取年级排名
     * @param studentScoreDto
     * @return
     */
    StudentScoreDetails getStudentScoreRankByGrade(StudentScoreDto studentScoreDto);

    /**
     * 获取一次学生分数年级排名
     * @param studentScoreDto
     * @return
     */
    StudentScoreDetails getStudentScoreRankByGradeOne(StudentScoreDto studentScoreDto);

    /**
     * 获取学生总分
     * @param studentScoreDto
     * @return
     */
    StudentScoreDetails getStudentTotalScore(StudentScoreDto studentScoreDto);

    /**
     * 获取分数趋势
     * @param studentScoreDto
     * @return
     */
    List<ScoreTable> getScoreTable(StudentScoreDto studentScoreDto);

    /**
     * 获取班级排名趋势
     * @param studentScoreDto
     * @return
     */
    List<Map<String,Object>> getClassRankTable(StudentScoreDto studentScoreDto);

    /**
     * 获取年级排名趋势
     * @param studentScoreDto
     * @return
     */
    List<Map<String,Object>> getGradeRankTable(StudentScoreDto studentScoreDto);

    /**
     * 获取学生考试学科列表
     * @param studentScoreDto
     * @return
     */
    List<Map<String,String>> getSubjectsName(StudentScoreDto studentScoreDto);

}
