package com.ipsa.learn.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.time.LocalDateTime;
import java.io.Serializable;

/**
 * <p>
 * 代课申请
 * </p>
 *
 * @author 1079626511@qq.com
 * @since 2020-08-31
 */
@Data
@TableName("course_application")
public class CourseApplication implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 主键id
     */
    @TableId(value = "curriculum_id", type = IdType.AUTO)
    @ApiModelProperty("主键id")
    private Long curriculumId;

    /**
     * 学校编码
     */
    @ApiModelProperty("学校编码")
    private String schoolCode;

    /**
     * 学年
     */
    @ApiModelProperty("学年")
    private String schoolYear;

    /**
     * 学期
     */
    @ApiModelProperty("学期")
    private String semester;

    /**
     * 年级
     */
    @ApiModelProperty("年级")
    private String grade;

    /**
     * 班级
     */
    @ApiModelProperty("班级")
    private String classCode;

    /**
     * 课节
     */
    @ApiModelProperty("课节")
    private String classPeriod;

    /**
     * 调课时间
     */
    @ApiModelProperty("调课时间")
    private LocalDateTime applicationTime;

    /**
     * 代课时间string
     */
    @TableField(exist = false)
    @ApiModelProperty("代课时间String")
    private String stringApplicationTime;

    /**
     * 星期几
     */
    @ApiModelProperty("星期几")
    private String week;

    /**
     * 课程名称
     */
    @ApiModelProperty("课程名称")
    private String curriculumName;

    /**
     * 申请人
     */
    @ApiModelProperty("申请人")
    private String applicationName;

    /**
     * 代课人
     */
    @ApiModelProperty("代课人")
    private String replaceName;

    /**
     * 创建人
     */
    @ApiModelProperty("创建人")
    private String createUser;

    /**
     * 代课创建时间string
     */
    @TableField(exist = false)
    @ApiModelProperty("代课创建时间String")
    private String stringCreateTime;

    /**
     * 修改人
     */
    @ApiModelProperty("修改人")
    private String updateUser;

    /**
     * 创建时间
     */
    @ApiModelProperty("创建时间")
    private LocalDateTime createTime;

    /**
     * 修改时间
     */
    @ApiModelProperty("修改时间")
    private LocalDateTime updateTime;

    /**
     * 0是删除 1正常
     */
    @ApiModelProperty("0是删除 1正常")
    private Integer yn;

    /**
     * 申请状态(0待审核1审核通过2审核不通过)
     */
    @ApiModelProperty("申请状态(0待审核1审核通过2审核不通过)")
    private Integer status;

    /**
     * 申请原因(0因公1因私)
     */
    @ApiModelProperty("申请原因(0因公1因私)")
    private Integer reasons;

    /**
     * 说明
     */
    @ApiModelProperty("说明")
    private String remarks;

    /**
     * 年级名称
     */
    private String gradeName;

    /**
     * 班级名称
     */
    private String className;

    /**
     * 审核说明
     */
    private String audit;

    public String getStringApplicationTime() {
        return stringApplicationTime;
    }

    public void setStringApplicationTime(String stringApplicationTime) {
        this.stringApplicationTime = stringApplicationTime;
    }

    public String getStringCreateTime() {
        return stringCreateTime;
    }

    public void setStringCreateTime(String stringCreateTime) {
        this.stringCreateTime = stringCreateTime;
    }

    public String getAudit() {
        return audit;
    }

    public void setAudit(String audit) {
        this.audit = audit;
    }

    public String getGradeName() {
        return gradeName;
    }

    public void setGradeName(String gradeName) {
        this.gradeName = gradeName;
    }

    public String getClassName() {
        return className;
    }

    public void setClassName(String className) {
        this.className = className;
    }

    public Long getCurriculumId() {
        return curriculumId;
    }

    public void setCurriculumId(Long curriculumId) {
        this.curriculumId = curriculumId;
    }

    public String getSchoolCode() {
        return schoolCode;
    }

    public void setSchoolCode(String schoolCode) {
        this.schoolCode = schoolCode;
    }

    public String getSchoolYear() {
        return schoolYear;
    }

    public void setSchoolYear(String schoolYear) {
        this.schoolYear = schoolYear;
    }

    public String getSemester() {
        return semester;
    }

    public void setSemester(String semester) {
        this.semester = semester;
    }

    public String getGrade() {
        return grade;
    }

    public void setGrade(String grade) {
        this.grade = grade;
    }

    public String getClassCode() {
        return classCode;
    }

    public void setClassCode(String classCode) {
        this.classCode = classCode;
    }

    public String getClassPeriod() {
        return classPeriod;
    }

    public void setClassPeriod(String classPeriod) {
        this.classPeriod = classPeriod;
    }

    public LocalDateTime getApplicationTime() {
        return applicationTime;
    }

    public void setApplicationTime(LocalDateTime applicationTime) {
        this.applicationTime = applicationTime;
    }

    public String getWeek() {
        return week;
    }

    public void setWeek(String week) {
        this.week = week;
    }

    public String getCurriculumName() {
        return curriculumName;
    }

    public void setCurriculumName(String curriculumName) {
        this.curriculumName = curriculumName;
    }

    public String getApplicationName() {
        return applicationName;
    }

    public void setApplicationName(String applicationName) {
        this.applicationName = applicationName;
    }

    public String getReplaceName() {
        return replaceName;
    }

    public void setReplaceName(String replaceName) {
        this.replaceName = replaceName;
    }

    public String getCreateUser() {
        return createUser;
    }

    public void setCreateUser(String createUser) {
        this.createUser = createUser;
    }

    public String getUpdateUser() {
        return updateUser;
    }

    public void setUpdateUser(String updateUser) {
        this.updateUser = updateUser;
    }

    public LocalDateTime getCreateTime() {
        return createTime;
    }

    public void setCreateTime(LocalDateTime createTime) {
        this.createTime = createTime;
    }

    public LocalDateTime getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(LocalDateTime updateTime) {
        this.updateTime = updateTime;
    }

    public Integer getYn() {
        return yn;
    }

    public void setYn(Integer yn) {
        this.yn = yn;
    }

    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    public Integer getReasons() {
        return reasons;
    }

    public void setReasons(Integer reasons) {
        this.reasons = reasons;
    }

    public String getRemarks() {
        return remarks;
    }

    public void setRemarks(String remarks) {
        this.remarks = remarks;
    }

    @Override
    public String toString() {
        return "CourseApplication{" +
                "curriculumId=" + curriculumId +
                ", schoolCode='" + schoolCode + '\'' +
                ", schoolYear='" + schoolYear + '\'' +
                ", semester='" + semester + '\'' +
                ", grade='" + grade + '\'' +
                ", classCode='" + classCode + '\'' +
                ", classPeriod='" + classPeriod + '\'' +
                ", applicationTime=" + applicationTime +
                ", stringApplicationTime='" + stringApplicationTime + '\'' +
                ", week='" + week + '\'' +
                ", curriculumName='" + curriculumName + '\'' +
                ", applicationName='" + applicationName + '\'' +
                ", replaceName='" + replaceName + '\'' +
                ", createUser='" + createUser + '\'' +
                ", stringCreateTime='" + stringCreateTime + '\'' +
                ", updateUser='" + updateUser + '\'' +
                ", createTime=" + createTime +
                ", updateTime=" + updateTime +
                ", yn=" + yn +
                ", status=" + status +
                ", reasons=" + reasons +
                ", remarks='" + remarks + '\'' +
                ", gradeName='" + gradeName + '\'' +
                ", className='" + className + '\'' +
                ", audit='" + audit + '\'' +
                '}';
    }
}
