package com.ipsa.learn.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.time.LocalDateTime;
import java.io.Serializable;

/**
 * <p>
 * 日常检查
 * </p>
 *
 * @author 1079626511@qq.com
 * @since 2020-09-03
 */
@Data
@TableName("course_dailycheck")
public class CourseDailycheck implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 主键id
     */
    @TableId(value = "dailycheck_id", type = IdType.AUTO)
    @ApiModelProperty("主键id")
    private Long dailycheckId;

    /**
     * 学校编码
     */
    @ApiModelProperty("学校编码")
    private String schoolCode;

    /**
     * 学校名称
     */
    @ApiModelProperty("学校名称")
    private String schoolName;

    /**
     * 学年
     */
    @ApiModelProperty("学年")
    private String schoolYear;

    /**
     * 学期
     */
    @ApiModelProperty("学期")
    private String semester;

    /**
     * 年级
     */
    @ApiModelProperty("年级")
    private String grade;

    /**
     * 年级名称
     */
    @ApiModelProperty("年级名称")
    private String gradeName;

    /**
     * 班级
     */
    @ApiModelProperty("班级")
    private String classCode;

    /**
     * 班级名称
     */
    @ApiModelProperty("班级名称")
    private String className;

    /**
     * 事项 01学生品行 02班级纪律 03个人素养 04卫生方面 05品德与表现
     */
    @ApiModelProperty("事项 01学生品行 02班级纪律 03个人素养 04卫生方面 05品德与表现")
    private String classMatters;

    /**
     * 分值
     */
    @ApiModelProperty("分值")
    private String classScore;

    /**
     * 说明
     */
    @ApiModelProperty("说明")
    private String classInstructions;

    /**
     * 拍照
     */
    @ApiModelProperty("拍照")
    private String classPictures;

    /**
     * 创建人
     */
    @ApiModelProperty("创建人")
    private String createUser;

    /**
     * 修改人
     */
    @ApiModelProperty("修改人")
    private String updateUser;

    /**
     * 创建时间
     */
    @ApiModelProperty("创建时间")
    private LocalDateTime createTime;

    /**
     * 创建时间string
     */
    @TableField(exist = false)
    @ApiModelProperty("创建时间String")
    private String stringCreateTime;

    /**
     * 修改时间
     */
    @ApiModelProperty("修改时间")
    private LocalDateTime updateTime;

    /**
     * 0是删除 1正常
     */
    @ApiModelProperty("0是删除 1正常")
    private Integer yn;


    public Long getDailycheckId() {
        return dailycheckId;
    }

    public void setDailycheckId(Long dailycheckId) {
        this.dailycheckId = dailycheckId;
    }

    public String getSchoolCode() {
        return schoolCode;
    }

    public void setSchoolCode(String schoolCode) {
        this.schoolCode = schoolCode;
    }

    public String getSchoolName() {
        return schoolName;
    }

    public void setSchoolName(String schoolName) {
        this.schoolName = schoolName;
    }

    public String getSchoolYear() {
        return schoolYear;
    }

    public void setSchoolYear(String schoolYear) {
        this.schoolYear = schoolYear;
    }

    public String getSemester() {
        return semester;
    }

    public void setSemester(String semester) {
        this.semester = semester;
    }

    public String getGrade() {
        return grade;
    }

    public void setGrade(String grade) {
        this.grade = grade;
    }

    public String getGradeName() {
        return gradeName;
    }

    public void setGradeName(String gradeName) {
        this.gradeName = gradeName;
    }

    public String getClassCode() {
        return classCode;
    }

    public void setClassCode(String classCode) {
        this.classCode = classCode;
    }

    public String getClassName() {
        return className;
    }

    public void setClassName(String className) {
        this.className = className;
    }

    public String getClassMatters() {
        return classMatters;
    }

    public void setClassMatters(String classMatters) {
        this.classMatters = classMatters;
    }

    public String getClassScore() {
        return classScore;
    }

    public void setClassScore(String classScore) {
        this.classScore = classScore;
    }

    public String getClassInstructions() {
        return classInstructions;
    }

    public void setClassInstructions(String classInstructions) {
        this.classInstructions = classInstructions;
    }

    public String getClassPictures() {
        return classPictures;
    }

    public void setClassPictures(String classPictures) {
        this.classPictures = classPictures;
    }

    public String getCreateUser() {
        return createUser;
    }

    public void setCreateUser(String createUser) {
        this.createUser = createUser;
    }

    public String getUpdateUser() {
        return updateUser;
    }

    public void setUpdateUser(String updateUser) {
        this.updateUser = updateUser;
    }

    public LocalDateTime getCreateTime() {
        return createTime;
    }

    public void setCreateTime(LocalDateTime createTime) {
        this.createTime = createTime;
    }

    public LocalDateTime getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(LocalDateTime updateTime) {
        this.updateTime = updateTime;
    }

    public Integer getYn() {
        return yn;
    }

    public void setYn(Integer yn) {
        this.yn = yn;
    }

    @Override
    public String toString() {
        return "CourseDailycheck{" +
                "dailycheckId=" + dailycheckId +
                ", schoolCode='" + schoolCode + '\'' +
                ", schoolName='" + schoolName + '\'' +
                ", schoolYear='" + schoolYear + '\'' +
                ", semester='" + semester + '\'' +
                ", grade='" + grade + '\'' +
                ", gradeName='" + gradeName + '\'' +
                ", classCode='" + classCode + '\'' +
                ", className='" + className + '\'' +
                ", classMatters='" + classMatters + '\'' +
                ", classScore='" + classScore + '\'' +
                ", classInstructions='" + classInstructions + '\'' +
                ", classPictures='" + classPictures + '\'' +
                ", createUser='" + createUser + '\'' +
                ", updateUser='" + updateUser + '\'' +
                ", createTime=" + createTime +
                ", updateTime=" + updateTime +
                ", yn=" + yn +
                '}';
    }
}
