package com.ipsa.learn.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import io.swagger.annotations.ApiModelProperty;

import java.time.LocalDateTime;
import java.io.Serializable;

/**
 * <p>
 * 成绩列表
 * </p>
 *
 * @author 1079626511@qq.com
 * @since 2020-09-04
 */
public class CourseResultlist implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 主键id
     */
    @ApiModelProperty("主键id")
    @TableId(value = "course_resultlist_id", type = IdType.AUTO)
    private Long courseResultlistId;

    /**
     * 成绩上传列表id
     */
    @ApiModelProperty("成绩上传列表id")
    private String courseResultsuploadId;

    /**
     * 年级
     */
    @ApiModelProperty("年级")
    private String grade;

    /**
     * 年级名称
     */
    @ApiModelProperty("年级名称")
    private String gradeName;

    /**
     * 班级
     */
    @ApiModelProperty("班级")
    private String classCode;

    /**
     * 班级名称
     */
    @ApiModelProperty("班级名称")
    private String className;

    /**
     * 科目名称
     */
    @ApiModelProperty("科目名称")
    private String subjectsName;

    /**
     * 考试名称
     */
    @ApiModelProperty("考试名称")
    private String testdateName;

    /**
     * 成绩人数
     */
    @ApiModelProperty("成绩人数")
    private String resultsNumbers;

    /**
     * 优秀人数
     */
    @ApiModelProperty("优秀人数")
    private String verygoodsNumbers;

    /**
     * 良好人数
     */
    @ApiModelProperty("良好人数")
    private String goodNumbers;

    /**
     * 及格人数
     */
    @ApiModelProperty("及格人数")
    private String passtheNumbers;

    /**
     * 不及格人数
     */
    @ApiModelProperty("不及格人数")
    private String dontpasstheNumbers;

    /**
     * 班级人数
     */
    @ApiModelProperty("班级人数")
    private String classNumbers;

    /**
     * 平均成绩
     */
    @ApiModelProperty("平均成绩")
    private String onaverageResults;

    /**
     * 优秀（A）、良好（B）、及格（C）、不及格（D）
     */
    @ApiModelProperty("优秀（A）、良好（B）、及格（C）、不及格（D）")
    private String subjectsOptimal;

    /**
     * 创建人
     */
    @ApiModelProperty("创建人")
    private String createUser;

    /**
     * 修改人
     */
    @ApiModelProperty("修改人")
    private String updateUser;

    /**
     * 创建时间
     */
    @ApiModelProperty("创建时间")
    private LocalDateTime createTime;

    /**
     * 修改时间
     */
    @ApiModelProperty("修改时间")
    private LocalDateTime updateTime;

    /**
     * 0是删除 1正常
     */
    @ApiModelProperty("0是删除 1正常")
    private Integer yn;


    public Long getCourseResultlistId() {
        return courseResultlistId;
    }

    public void setCourseResultlistId(Long courseResultlistId) {
        this.courseResultlistId = courseResultlistId;
    }

    public String getCourseResultsuploadId() {
        return courseResultsuploadId;
    }

    public void setCourseResultsuploadId(String courseResultsuploadId) {
        this.courseResultsuploadId = courseResultsuploadId;
    }

    public String getGrade() {
        return grade;
    }

    public void setGrade(String grade) {
        this.grade = grade;
    }

    public String getGradeName() {
        return gradeName;
    }

    public void setGradeName(String gradeName) {
        this.gradeName = gradeName;
    }

    public String getClassCode() {
        return classCode;
    }

    public void setClassCode(String classCode) {
        this.classCode = classCode;
    }

    public String getClassName() {
        return className;
    }

    public void setClassName(String className) {
        this.className = className;
    }

    public String getSubjectsName() {
        return subjectsName;
    }

    public void setSubjectsName(String subjectsName) {
        this.subjectsName = subjectsName;
    }

    public String getTestdateName() {
        return testdateName;
    }

    public void setTestdateName(String testdateName) {
        this.testdateName = testdateName;
    }

    public String getResultsNumbers() {
        return resultsNumbers;
    }

    public void setResultsNumbers(String resultsNumbers) {
        this.resultsNumbers = resultsNumbers;
    }

    public String getVerygoodsNumbers() {
        return verygoodsNumbers;
    }

    public void setVerygoodsNumbers(String verygoodsNumbers) {
        this.verygoodsNumbers = verygoodsNumbers;
    }

    public String getGoodNumbers() {
        return goodNumbers;
    }

    public void setGoodNumbers(String goodNumbers) {
        this.goodNumbers = goodNumbers;
    }

    public String getPasstheNumbers() {
        return passtheNumbers;
    }

    public void setPasstheNumbers(String passtheNumbers) {
        this.passtheNumbers = passtheNumbers;
    }

    public String getDontpasstheNumbers() {
        return dontpasstheNumbers;
    }

    public void setDontpasstheNumbers(String dontpasstheNumbers) {
        this.dontpasstheNumbers = dontpasstheNumbers;
    }

    public String getClassNumbers() {
        return classNumbers;
    }

    public void setClassNumbers(String classNumbers) {
        this.classNumbers = classNumbers;
    }

    public String getOnaverageResults() {
        return onaverageResults;
    }

    public void setOnaverageResults(String onaverageResults) {
        this.onaverageResults = onaverageResults;
    }

    public String getSubjectsOptimal() {
        return subjectsOptimal;
    }

    public void setSubjectsOptimal(String subjectsOptimal) {
        this.subjectsOptimal = subjectsOptimal;
    }

    public String getCreateUser() {
        return createUser;
    }

    public void setCreateUser(String createUser) {
        this.createUser = createUser;
    }

    public String getUpdateUser() {
        return updateUser;
    }

    public void setUpdateUser(String updateUser) {
        this.updateUser = updateUser;
    }

    public LocalDateTime getCreateTime() {
        return createTime;
    }

    public void setCreateTime(LocalDateTime createTime) {
        this.createTime = createTime;
    }

    public LocalDateTime getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(LocalDateTime updateTime) {
        this.updateTime = updateTime;
    }

    public Integer getYn() {
        return yn;
    }

    public void setYn(Integer yn) {
        this.yn = yn;
    }

    @Override
    public String toString() {
        return "CourseResultlist{" +
        "courseResultlistId=" + courseResultlistId +
        ", courseResultsuploadId=" + courseResultsuploadId +
        ", grade=" + grade +
        ", gradeName=" + gradeName +
        ", classCode=" + classCode +
        ", className=" + className +
        ", subjectsName=" + subjectsName +
        ", testdateName=" + testdateName +
        ", resultsNumbers=" + resultsNumbers +
        ", verygoodsNumbers=" + verygoodsNumbers +
        ", goodNumbers=" + goodNumbers +
        ", passtheNumbers=" + passtheNumbers +
        ", dontpasstheNumbers=" + dontpasstheNumbers +
        ", classNumbers=" + classNumbers +
        ", onaverageResults=" + onaverageResults +
        ", subjectsOptimal=" + subjectsOptimal +
        ", createUser=" + createUser +
        ", updateUser=" + updateUser +
        ", createTime=" + createTime +
        ", updateTime=" + updateTime +
        ", yn=" + yn +
        "}";
    }
}
