package com.ipsa.learn.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.time.LocalDateTime;
import java.io.Serializable;

/**
 * <p>
 * 考试上传
 * </p>
 *
 * @author 1079626511@qq.com
 * @since 2020-09-03
 */
@Data
@TableName("course_resultsupload")
public class CourseResultsupload implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 主键id
     */
    @TableId(value = "course_resultsupload_id", type = IdType.AUTO)
    @ApiModelProperty("主键id")
    private Long courseResultsuploadId;

    /**
     * 学校编码
     */
    @ApiModelProperty("学校编码")
    private String schoolCode;

    /**
     * 学校名称
     */
    @ApiModelProperty("学校名称")
    private String schoolName;

    /**
     * 学年
     */
    @ApiModelProperty("学年")
    private String schoolYear;

    /**
     * 学期
     */
    @ApiModelProperty("学期")
    private String semester;

    /**
     * 年级
     */
    @ApiModelProperty("年级")
    private String grade;

    /**
     * 年级名称
     */
    @ApiModelProperty("年级名称")
    private String gradeName;

    /**
     * 班级
     */
    @ApiModelProperty("班级")
    private String classCode;

    /**
     * 班级名称
     */
    @ApiModelProperty("班级名称")
    private String className;

    /**
     * 科目
     */
    @ApiModelProperty("科目")
    private String classSub;

    /**
     * 科目名称
     */
    @ApiModelProperty("科目名称")
    private String classSubname;

    /**
     * 考试日期
     */
    @ApiModelProperty("考试日期")
    private LocalDateTime testdateTime;

    /**
     * 考试日期string类
     */
    @TableField(exist = false)
    @ApiModelProperty("考试日期string类")
    private String stringTestdateTime;

    /**
     * 考试名称
     */
    @ApiModelProperty("考试名称")
    private String testdateName;

    /**
     * 创建人
     */
    @ApiModelProperty("创建人")
    private String createUser;

    /**
     * 修改人
     */
    @ApiModelProperty("修改人")
    private String updateUser;

    /**
     * 创建时间
     */
    @ApiModelProperty("创建时间")
    private LocalDateTime createTime;

    /**
     * 修改时间
     */
    @ApiModelProperty("修改时间")
    private LocalDateTime updateTime;

    /**
     * 0是删除 1正常
     */
    @ApiModelProperty("0是删除 1正常")
    private Integer yn;

    /**
     * 0未发布到班级群 1已发布到班级群
     */
    @ApiModelProperty("0未发布到班级群 1已发布到班级群")
    private Integer isPublish;


    public Long getCourseResultsuploadId() {
        return courseResultsuploadId;
    }

    public void setCourseResultsuploadId(Long courseResultsuploadId) {
        this.courseResultsuploadId = courseResultsuploadId;
    }

    public String getSchoolCode() {
        return schoolCode;
    }

    public void setSchoolCode(String schoolCode) {
        this.schoolCode = schoolCode;
    }

    public String getSchoolName() {
        return schoolName;
    }

    public void setSchoolName(String schoolName) {
        this.schoolName = schoolName;
    }

    public String getSchoolYear() {
        return schoolYear;
    }

    public void setSchoolYear(String schoolYear) {
        this.schoolYear = schoolYear;
    }

    public String getSemester() {
        return semester;
    }

    public void setSemester(String semester) {
        this.semester = semester;
    }

    public String getGrade() {
        return grade;
    }

    public void setGrade(String grade) {
        this.grade = grade;
    }

    public String getGradeName() {
        return gradeName;
    }

    public void setGradeName(String gradeName) {
        this.gradeName = gradeName;
    }

    public String getClassCode() {
        return classCode;
    }

    public void setClassCode(String classCode) {
        this.classCode = classCode;
    }

    public String getClassName() {
        return className;
    }

    public void setClassName(String className) {
        this.className = className;
    }

    public String getClassSub() {
        return classSub;
    }

    public void setClassSub(String classSub) {
        this.classSub = classSub;
    }

    public String getClassSubname() {
        return classSubname;
    }

    public void setClassSubname(String classSubname) {
        this.classSubname = classSubname;
    }

    public LocalDateTime getTestdateTime() {
        return testdateTime;
    }

    public void setTestdateTime(LocalDateTime testdateTime) {
        this.testdateTime = testdateTime;
    }

    public String getTestdateName() {
        return testdateName;
    }

    public void setTestdateName(String testdateName) {
        this.testdateName = testdateName;
    }

    public String getCreateUser() {
        return createUser;
    }

    public void setCreateUser(String createUser) {
        this.createUser = createUser;
    }

    public String getUpdateUser() {
        return updateUser;
    }

    public void setUpdateUser(String updateUser) {
        this.updateUser = updateUser;
    }

    public LocalDateTime getCreateTime() {
        return createTime;
    }

    public void setCreateTime(LocalDateTime createTime) {
        this.createTime = createTime;
    }

    public LocalDateTime getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(LocalDateTime updateTime) {
        this.updateTime = updateTime;
    }

    public Integer getYn() {
        return yn;
    }

    public void setYn(Integer yn) {
        this.yn = yn;
    }

    @Override
    public String toString() {
        return "CourseResultsupload{" +
        "courseResultsuploadId=" + courseResultsuploadId +
        ", schoolCode=" + schoolCode +
        ", schoolName=" + schoolName +
        ", schoolYear=" + schoolYear +
        ", semester=" + semester +
        ", grade=" + grade +
        ", gradeName=" + gradeName +
        ", classCode=" + classCode +
        ", className=" + className +
        ", classSub=" + classSub +
        ", classSubname=" + classSubname +
        ", testdateTime=" + testdateTime +
        ", testdateName=" + testdateName +
        ", createUser=" + createUser +
        ", updateUser=" + updateUser +
        ", createTime=" + createTime +
        ", updateTime=" + updateTime +
        ", yn=" + yn +
        "}";
    }
}
