package com.ipsa.learn.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import io.swagger.annotations.ApiModelProperty;

import java.time.LocalDateTime;
import java.io.Serializable;

/**
 * <p>
 * 科目分数表
 * </p>
 *
 * @author 1079626511@qq.com
 * @since 2020-09-03
 */
public class CourseScore implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 主键id
     */
    @TableId(value = "course_score_id", type = IdType.AUTO)
    @ApiModelProperty("主键id")
    private Long courseScoreId;

    /**
     * 成绩上传列表id
     */
    @ApiModelProperty("成绩上传列表id")
    private String courseResultsuploadId;

    /**
     * 学生id
     */
    @ApiModelProperty("学生id")
    private String studentUserId;

    /**
     * 学生姓名
     */
    @ApiModelProperty("学生姓名")
    private String studentUserName;

    /**
     * 科目分数
     */
    @ApiModelProperty("科目分数")
    private String subjectsScores;

    /**
     * 优秀（A）、良好（B）、及格（C）、不及格（D）
     */
    @ApiModelProperty("优秀（A）、良好（B）、及格（C）、不及格（D）")
    private String subjectsOptimal;

    /**
     * 创建人
     */
    @ApiModelProperty("创建人")
    private String createUser;

    /**
     * 修改人
     */
    @ApiModelProperty("修改人")
    private String updateUser;

    /**
     * 创建时间
     */
    @ApiModelProperty("创建时间")
    private LocalDateTime createTime;

    /**
     * 修改时间
     */
    @ApiModelProperty("修改时间")
    private LocalDateTime updateTime;

    /**
     * 0是删除 1正常
     */
    @ApiModelProperty("0是删除 1正常")
    private Integer yn;

    /**
     * 学生编号
     */
    @ApiModelProperty("学生编号")
    private String studentNo;

    /**
     * 科目名称
     */
    @ApiModelProperty("科目名称")
    private String subjectsName;


    public Long getCourseScoreId() {
        return courseScoreId;
    }

    public void setCourseScoreId(Long courseScoreId) {
        this.courseScoreId = courseScoreId;
    }

    public String getCourseResultsuploadId() {
        return courseResultsuploadId;
    }

    public void setCourseResultsuploadId(String courseResultsuploadId) {
        this.courseResultsuploadId = courseResultsuploadId;
    }

    public String getStudentUserId() {
        return studentUserId;
    }

    public void setStudentUserId(String studentUserId) {
        this.studentUserId = studentUserId;
    }

    public String getStudentUserName() {
        return studentUserName;
    }

    public void setStudentUserName(String studentUserName) {
        this.studentUserName = studentUserName;
    }

    public String getSubjectsScores() {
        return subjectsScores;
    }

    public void setSubjectsScores(String subjectsScores) {
        this.subjectsScores = subjectsScores;
    }

    public String getSubjectsOptimal() {
        return subjectsOptimal;
    }

    public void setSubjectsOptimal(String subjectsOptimal) {
        this.subjectsOptimal = subjectsOptimal;
    }

    public String getCreateUser() {
        return createUser;
    }

    public void setCreateUser(String createUser) {
        this.createUser = createUser;
    }

    public String getUpdateUser() {
        return updateUser;
    }

    public void setUpdateUser(String updateUser) {
        this.updateUser = updateUser;
    }

    public LocalDateTime getCreateTime() {
        return createTime;
    }

    public void setCreateTime(LocalDateTime createTime) {
        this.createTime = createTime;
    }

    public LocalDateTime getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(LocalDateTime updateTime) {
        this.updateTime = updateTime;
    }

    public Integer getYn() {
        return yn;
    }

    public void setYn(Integer yn) {
        this.yn = yn;
    }

    public String getStudentNo() {
        return studentNo;
    }

    public void setStudentNo(String studentNo) {
        this.studentNo = studentNo;
    }

    public String getSubjectsName() {
        return subjectsName;
    }

    public void setSubjectsName(String subjectsName) {
        this.subjectsName = subjectsName;
    }

    @Override
    public String toString() {
        return "CourseScore{" +
                "courseScoreId=" + courseScoreId +
                ", courseResultsuploadId=" + courseResultsuploadId +
                ", studentUserId=" + studentUserId +
                ", studentUserName=" + studentUserName +
                ", subjectsScores=" + subjectsScores +
                ", subjectsOptimal=" + subjectsOptimal +
                ", createUser=" + createUser +
                ", updateUser=" + updateUser +
                ", createTime=" + createTime +
                ", updateTime=" + updateTime +
                ", yn=" + yn +
                ", studentNo=" + studentNo +
                ", subjectsName=" + subjectsName +
                "}";
    }
}
