package com.ipsa.learn.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.time.LocalDateTime;
import java.io.Serializable;

/**
 * <p>
 * 科目表
 * </p>
 *
 * @author 1079626511@qq.com
 * @since 2020-09-03
 */
@Data
@TableName("course_subjects")
public class CourseSubjects implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 主键id
     */
    @TableId(value = "course_subjects_id", type = IdType.AUTO)
    @ApiModelProperty("主键id")
    private Long courseSubjectsId;

    /**
     * 学校编码
     */
    @ApiModelProperty("学校编码")
    private String schoolCode;

    /**
     * 学校名称
     */
    @ApiModelProperty("学校名称")
    private String schoolName;

    /**
     * 科目编码
     */
    @ApiModelProperty("科目编码")
    private String subjectsCode;

    /**
     * 科目名称
     */
    @ApiModelProperty("科目名称")
    private String subjectsName;

    /**
     * 年级编码
     */
    @ApiModelProperty("年级编码")
    private String gradeCode;

    /**
     * 年级名称
     */
    @ApiModelProperty("年级名称")
    private String gradeName;

    /**
     * 创建人
     */
    @ApiModelProperty("创建人")
    private String createUser;

    /**
     * 修改人
     */
    @ApiModelProperty("修改人")
    private String updateUser;

    /**
     * 创建时间
     */
    @ApiModelProperty("创建时间")
    private LocalDateTime createTime;

    /**
     * 修改时间
     */
    @ApiModelProperty("修改时间")
    private LocalDateTime updateTime;

    /**
     * 0是删除 1正常
     */
    @ApiModelProperty("0是删除 1正常")
    private Integer yn;


    public Long getCourseSubjectsId() {
        return courseSubjectsId;
    }

    public void setCourseSubjectsId(Long courseSubjectsId) {
        this.courseSubjectsId = courseSubjectsId;
    }

    public String getSchoolCode() {
        return schoolCode;
    }

    public void setSchoolCode(String schoolCode) {
        this.schoolCode = schoolCode;
    }

    public String getSchoolName() {
        return schoolName;
    }

    public void setSchoolName(String schoolName) {
        this.schoolName = schoolName;
    }

    public String getSubjectsCode() {
        return subjectsCode;
    }

    public void setSubjectsCode(String subjectsCode) {
        this.subjectsCode = subjectsCode;
    }

    public String getSubjectsName() {
        return subjectsName;
    }

    public void setSubjectsName(String subjectsName) {
        this.subjectsName = subjectsName;
    }

    public String getGradeCode() {
        return gradeCode;
    }

    public void setGradeCode(String gradeCode) {
        this.gradeCode = gradeCode;
    }

    public String getGradeName() {
        return gradeName;
    }

    public void setGradeName(String gradeName) {
        this.gradeName = gradeName;
    }

    public String getCreateUser() {
        return createUser;
    }

    public void setCreateUser(String createUser) {
        this.createUser = createUser;
    }

    public String getUpdateUser() {
        return updateUser;
    }

    public void setUpdateUser(String updateUser) {
        this.updateUser = updateUser;
    }

    public LocalDateTime getCreateTime() {
        return createTime;
    }

    public void setCreateTime(LocalDateTime createTime) {
        this.createTime = createTime;
    }

    public LocalDateTime getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(LocalDateTime updateTime) {
        this.updateTime = updateTime;
    }

    public Integer getYn() {
        return yn;
    }

    public void setYn(Integer yn) {
        this.yn = yn;
    }

    @Override
    public String toString() {
        return "CourseSubjects{" +
        "courseSubjectsId=" + courseSubjectsId +
        ", schoolCode=" + schoolCode +
        ", schoolName=" + schoolName +
        ", subjectsCode=" + subjectsCode +
        ", subjectsName=" + subjectsName +
        ", gradeCode=" + gradeCode +
        ", gradeName=" + gradeName +
        ", createUser=" + createUser +
        ", updateUser=" + updateUser +
        ", createTime=" + createTime +
        ", updateTime=" + updateTime +
        ", yn=" + yn +
        "}";
    }
}
