package com.ipsa.learn.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.time.LocalDateTime;
import java.io.Serializable;

/**
 * <p>
 * 调课申请
 * </p>
 *
 * @author 1079626511@qq.com
 * @since 2020-08-31
 */
@Data
@TableName("course_transfer")
public class CourseTransfer implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 主键id
     */
    @TableId(value = "course_transfer_id", type = IdType.AUTO)
    @ApiModelProperty("主键id")
    private Long courseTransferId;

    /**
     * 学校编码
     */
    @ApiModelProperty("学校编码")
    private String schoolCode;

    /**
     * 学年
     */
    @ApiModelProperty("学年")
    private String schoolYear;

    /**
     * 学期
     */
    @ApiModelProperty("学期")
    private String semester;

    /**
     * 年级
     */
    @ApiModelProperty("年级")
    private String grade;

    /**
     * 班级
     */
    @ApiModelProperty("班级")
    private String classCode;

    /**
     * 课节
     */
    @ApiModelProperty("课节")
    private String classPeriod;

    /**
     * 调课时间
     */
    @ApiModelProperty("调课时间")
    private LocalDateTime applicationTime;

    /**
     * 星期几
     */
    @ApiModelProperty("星期几")
    private String week;

    /**
     * 课程名称
     */
    @ApiModelProperty("课程名称")
    private String curriculumName;

    /**
     * 申请人
     */
    @ApiModelProperty("申请人")
    private String applicationName;

    /**
     * 代课人
     */
    @ApiModelProperty("代课人")
    private String replaceName;

    /**
     * 创建人
     */
    @ApiModelProperty("创建人")
    private String createUser;

    /**
     * 修改人
     */
    @ApiModelProperty("修改人")
    private String updateUser;

    /**
     * 创建时间
     */
    @ApiModelProperty("创建时间")
    private LocalDateTime createTime;

    /**
     * 调课创建时间string
     */
    @TableField(exist = false)
    @ApiModelProperty("调课创建时间String")
    private String stringCreateTime;

    /**
     * 修改时间
     */
    @ApiModelProperty("修改时间")
    private LocalDateTime updateTime;

    /**
     * 0是删除 1正常
     */
    @ApiModelProperty("0是删除 1正常")
    private Integer yn;

    /**
     * 调年级
     */
    @ApiModelProperty("调年级")
    private String gradeGrade;

    /**
     * 调班级
     */
    @ApiModelProperty("调班级")
    private String classGrade;

    /**
     * 调课节
     */
    @ApiModelProperty("调课节")
    private String classPeriodGrade;

    /**
     * 调课时间
     */
    @ApiModelProperty("调课时间")
    private LocalDateTime applicationTimeGrade;

    /**
     * 调课时间string
     */
    @TableField(exist = false)
    @ApiModelProperty("调课时间String")
    private String stringApplicationTimeGrade;

    /**
     * 调星期几
     */
    @ApiModelProperty("调星期几")
    private String weekGrade;

    /**
     * 调课程名称
     */
    @ApiModelProperty("调课程名称")
    private String curriculumNameGrade;

    /**
     * 申请状态(0待审核1审核通过)
     */
    @ApiModelProperty("申请状态(0待审核1审核通过2审核未通过)")
    private Integer status;

    /**
     * 说明
     */
    @ApiModelProperty("说明")
    private String remarks;

    /**
     * 申请原因(0因公1因私)
     */
    @ApiModelProperty("申请原因(0因公1因私)")
    private Integer reasons;


    /**
     * 年级名称
     */
    @ApiModelProperty("年级名称")
    private String gradeName;

    /**
     * 班级名称
     */
    @ApiModelProperty("班级名称")
    private String className;

    /**
     * 调年级的名称
     */
    @ApiModelProperty("调年级的名称")
    private String gradeGradeName;

    /**
     * 调班级的名称
     */
    @ApiModelProperty("调班级的名称")
    private String classGradeName;

    /**
     * 审核说明
     */
    private String audit;

    public String getStringCreateTime() {
        return stringCreateTime;
    }

    public void setStringCreateTime(String stringCreateTime) {
        this.stringCreateTime = stringCreateTime;
    }

    public String getStringApplicationTimeGrade() {
        return stringApplicationTimeGrade;
    }

    public void setStringApplicationTimeGrade(String stringApplicationTimeGrade) {
        this.stringApplicationTimeGrade = stringApplicationTimeGrade;
    }

    public String getAudit() {
        return audit;
    }

    public void setAudit(String audit) {
        this.audit = audit;
    }

    public Long getCourseTransferId() {
        return courseTransferId;
    }

    public void setCourseTransferId(Long courseTransferId) {
        this.courseTransferId = courseTransferId;
    }

    public String getSchoolCode() {
        return schoolCode;
    }

    public void setSchoolCode(String schoolCode) {
        this.schoolCode = schoolCode;
    }

    public String getSchoolYear() {
        return schoolYear;
    }

    public void setSchoolYear(String schoolYear) {
        this.schoolYear = schoolYear;
    }

    public String getSemester() {
        return semester;
    }

    public void setSemester(String semester) {
        this.semester = semester;
    }

    public String getGrade() {
        return grade;
    }

    public void setGrade(String grade) {
        this.grade = grade;
    }

    public String getClassCode() {
        return classCode;
    }

    public void setClassCode(String classCode) {
        this.classCode = classCode;
    }

    public String getClassPeriod() {
        return classPeriod;
    }

    public void setClassPeriod(String classPeriod) {
        this.classPeriod = classPeriod;
    }

    public LocalDateTime getApplicationTime() {
        return applicationTime;
    }

    public void setApplicationTime(LocalDateTime applicationTime) {
        this.applicationTime = applicationTime;
    }

    public String getWeek() {
        return week;
    }

    public void setWeek(String week) {
        this.week = week;
    }

    public String getCurriculumName() {
        return curriculumName;
    }

    public void setCurriculumName(String curriculumName) {
        this.curriculumName = curriculumName;
    }

    public String getApplicationName() {
        return applicationName;
    }

    public void setApplicationName(String applicationName) {
        this.applicationName = applicationName;
    }

    public String getReplaceName() {
        return replaceName;
    }

    public void setReplaceName(String replaceName) {
        this.replaceName = replaceName;
    }

    public String getCreateUser() {
        return createUser;
    }

    public void setCreateUser(String createUser) {
        this.createUser = createUser;
    }

    public String getUpdateUser() {
        return updateUser;
    }

    public void setUpdateUser(String updateUser) {
        this.updateUser = updateUser;
    }

    public LocalDateTime getCreateTime() {
        return createTime;
    }

    public void setCreateTime(LocalDateTime createTime) {
        this.createTime = createTime;
    }

    public LocalDateTime getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(LocalDateTime updateTime) {
        this.updateTime = updateTime;
    }

    public Integer getYn() {
        return yn;
    }

    public void setYn(Integer yn) {
        this.yn = yn;
    }

    public String getGradeGrade() {
        return gradeGrade;
    }

    public void setGradeGrade(String gradeGrade) {
        this.gradeGrade = gradeGrade;
    }

    public String getClassGrade() {
        return classGrade;
    }

    public void setClassGrade(String classGrade) {
        this.classGrade = classGrade;
    }

    public String getClassPeriodGrade() {
        return classPeriodGrade;
    }

    public void setClassPeriodGrade(String classPeriodGrade) {
        this.classPeriodGrade = classPeriodGrade;
    }

    public LocalDateTime getApplicationTimeGrade() {
        return applicationTimeGrade;
    }

    public void setApplicationTimeGrade(LocalDateTime applicationTimeGrade) {
        this.applicationTimeGrade = applicationTimeGrade;
    }

    public String getWeekGrade() {
        return weekGrade;
    }

    public void setWeekGrade(String weekGrade) {
        this.weekGrade = weekGrade;
    }

    public String getCurriculumNameGrade() {
        return curriculumNameGrade;
    }

    public void setCurriculumNameGrade(String curriculumNameGrade) {
        this.curriculumNameGrade = curriculumNameGrade;
    }

    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    public String getRemarks() {
        return remarks;
    }

    public void setRemarks(String remarks) {
        this.remarks = remarks;
    }

    public Integer getReasons() {
        return reasons;
    }

    public void setReasons(Integer reasons) {
        this.reasons = reasons;
    }

    public String getGradeName() {
        return gradeName;
    }

    public void setGradeName(String gradeName) {
        this.gradeName = gradeName;
    }

    public String getClassName() {
        return className;
    }

    public void setClassName(String className) {
        this.className = className;
    }

    public String getGradeGradeName() {
        return gradeGradeName;
    }

    public void setGradeGradeName(String gradeGradeName) {
        this.gradeGradeName = gradeGradeName;
    }

    public String getClassGradeName() {
        return classGradeName;
    }

    public void setClassGradeName(String classGradeName) {
        this.classGradeName = classGradeName;
    }

    @Override
    public String toString() {
        return "CourseTransfer{" +
                "courseTransferId=" + courseTransferId +
                ", schoolCode='" + schoolCode + '\'' +
                ", schoolYear='" + schoolYear + '\'' +
                ", semester='" + semester + '\'' +
                ", grade='" + grade + '\'' +
                ", classCode='" + classCode + '\'' +
                ", classPeriod='" + classPeriod + '\'' +
                ", applicationTime=" + applicationTime +
                ", week='" + week + '\'' +
                ", curriculumName='" + curriculumName + '\'' +
                ", applicationName='" + applicationName + '\'' +
                ", replaceName='" + replaceName + '\'' +
                ", createUser='" + createUser + '\'' +
                ", updateUser='" + updateUser + '\'' +
                ", createTime=" + createTime +
                ", stringCreateTime='" + stringCreateTime + '\'' +
                ", updateTime=" + updateTime +
                ", yn=" + yn +
                ", gradeGrade='" + gradeGrade + '\'' +
                ", classGrade='" + classGrade + '\'' +
                ", classPeriodGrade='" + classPeriodGrade + '\'' +
                ", applicationTimeGrade=" + applicationTimeGrade +
                ", stringApplicationTimeGrade='" + stringApplicationTimeGrade + '\'' +
                ", weekGrade='" + weekGrade + '\'' +
                ", curriculumNameGrade='" + curriculumNameGrade + '\'' +
                ", status=" + status +
                ", remarks='" + remarks + '\'' +
                ", reasons=" + reasons +
                ", gradeName='" + gradeName + '\'' +
                ", className='" + className + '\'' +
                ", gradeGradeName='" + gradeGradeName + '\'' +
                ", classGradeName='" + classGradeName + '\'' +
                ", audit='" + audit + '\'' +
                '}';
    }
}
