package com.ipsa.learn.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.time.LocalDateTime;
import java.io.Serializable;

/**
 * <p>
 * 排课表
 * </p>
 *
 * @author 1079626511@qq.com
 * @since 2020-09-03
 */
@Data
@TableName("curriculum")
public class Curriculum implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 主键id
     */
    @TableId(value = "curriculum_id", type = IdType.AUTO)
    @ApiModelProperty("主键id")
    private Long curriculumId;

    /**
     * 学校编码
     */
    @ApiModelProperty("学校编码")
    private String schoolCode;

    /**
     * 学年
     */
    @ApiModelProperty("学年")
    private String schoolYear;

    /**
     * 学期
     */
    @ApiModelProperty("学期")
    private String semester;

    /**
     * 年级
     */
    @ApiModelProperty("年级")
    private String grade;

    /**
     * 班级
     */
    @ApiModelProperty("班级")
    private String classCode;

    /**
     * 课节
     */
    @ApiModelProperty("课节")
    private String classPeriod;

    /**
     * 周一课程
     */
    @ApiModelProperty("周一课程")
    private String mondayCurriculum;

    /**
     * 周二课程
     */
    @ApiModelProperty("周二课程")
    private String tuesdayCurriculum;

    /**
     * 周三课程
     */
    @ApiModelProperty("周三课程")
    private String wednesdayCurriculum;

    /**
     * 周四课程
     */
    @ApiModelProperty("周四课程")
    private String thursdayCurriculum;

    /**
     * 周五课程
     */
    @ApiModelProperty("周五课程")
    private String fridayCurriculum;

    /**
     * 创建人
     */
    @ApiModelProperty("创建人")
    private String createUser;

    /**
     * 修改人
     */
    @ApiModelProperty("修改人")
    private String updateUser;

    /**
     * 创建时间
     */
    @ApiModelProperty("创建时间")
    private LocalDateTime createTime;

    /**
     * 修改时间
     */
    @ApiModelProperty("修改时间")
    private LocalDateTime updateTime;

    /**
     * 0是删除 1正常
     */
    @ApiModelProperty("0是删除 1正常")
    private Integer yn;

    /**
     * 周一代课老师
     */
    @ApiModelProperty("周一代课老师")
    private String mondayTeacher;

    /**
     * 周二代课老师
     */
    @ApiModelProperty("周二代课老师")
    private String tuesdayTeacher;

    /**
     * 周三代课老师
     */
    @ApiModelProperty("周三代课老师")
    private String wednesdayTeacher;

    /**
     * 周四代课老师
     */
    @ApiModelProperty("周四代课老师")
    private String thursdayTeacher;

    /**
     * 周五代课老师
     */
    @ApiModelProperty("周五代课老师")
    private String fridayTeacher;

    /**
     * 班级名称
     */
    @ApiModelProperty("班级名称")
    private String className;

    /**
     * 学校名称
     */
    @ApiModelProperty("学校名称")
    private String schoolName;

    /**
     * 年级名称
     */
    @ApiModelProperty("年级名称")
    private String gradeName;


    public Long getCurriculumId() {
        return curriculumId;
    }

    public void setCurriculumId(Long curriculumId) {
        this.curriculumId = curriculumId;
    }

    public String getSchoolCode() {
        return schoolCode;
    }

    public void setSchoolCode(String schoolCode) {
        this.schoolCode = schoolCode;
    }

    public String getSchoolYear() {
        return schoolYear;
    }

    public void setSchoolYear(String schoolYear) {
        this.schoolYear = schoolYear;
    }

    public String getSemester() {
        return semester;
    }

    public void setSemester(String semester) {
        this.semester = semester;
    }

    public String getGrade() {
        return grade;
    }

    public void setGrade(String grade) {
        this.grade = grade;
    }

    public String getClassCode() {
        return classCode;
    }

    public void setClassCode(String classCode) {
        this.classCode = classCode;
    }

    public String getClassPeriod() {
        return classPeriod;
    }

    public void setClassPeriod(String classPeriod) {
        this.classPeriod = classPeriod;
    }

    public String getMondayCurriculum() {
        return mondayCurriculum;
    }

    public void setMondayCurriculum(String mondayCurriculum) {
        this.mondayCurriculum = mondayCurriculum;
    }

    public String getTuesdayCurriculum() {
        return tuesdayCurriculum;
    }

    public void setTuesdayCurriculum(String tuesdayCurriculum) {
        this.tuesdayCurriculum = tuesdayCurriculum;
    }

    public String getWednesdayCurriculum() {
        return wednesdayCurriculum;
    }

    public void setWednesdayCurriculum(String wednesdayCurriculum) {
        this.wednesdayCurriculum = wednesdayCurriculum;
    }

    public String getThursdayCurriculum() {
        return thursdayCurriculum;
    }

    public void setThursdayCurriculum(String thursdayCurriculum) {
        this.thursdayCurriculum = thursdayCurriculum;
    }

    public String getFridayCurriculum() {
        return fridayCurriculum;
    }

    public void setFridayCurriculum(String fridayCurriculum) {
        this.fridayCurriculum = fridayCurriculum;
    }

    public String getCreateUser() {
        return createUser;
    }

    public void setCreateUser(String createUser) {
        this.createUser = createUser;
    }

    public String getUpdateUser() {
        return updateUser;
    }

    public void setUpdateUser(String updateUser) {
        this.updateUser = updateUser;
    }

    public LocalDateTime getCreateTime() {
        return createTime;
    }

    public void setCreateTime(LocalDateTime createTime) {
        this.createTime = createTime;
    }

    public LocalDateTime getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(LocalDateTime updateTime) {
        this.updateTime = updateTime;
    }

    public Integer getYn() {
        return yn;
    }

    public void setYn(Integer yn) {
        this.yn = yn;
    }

    public String getMondayTeacher() {
        return mondayTeacher;
    }

    public void setMondayTeacher(String mondayTeacher) {
        this.mondayTeacher = mondayTeacher;
    }

    public String getTuesdayTeacher() {
        return tuesdayTeacher;
    }

    public void setTuesdayTeacher(String tuesdayTeacher) {
        this.tuesdayTeacher = tuesdayTeacher;
    }

    public String getWednesdayTeacher() {
        return wednesdayTeacher;
    }

    public void setWednesdayTeacher(String wednesdayTeacher) {
        this.wednesdayTeacher = wednesdayTeacher;
    }

    public String getThursdayTeacher() {
        return thursdayTeacher;
    }

    public void setThursdayTeacher(String thursdayTeacher) {
        this.thursdayTeacher = thursdayTeacher;
    }

    public String getFridayTeacher() {
        return fridayTeacher;
    }

    public void setFridayTeacher(String fridayTeacher) {
        this.fridayTeacher = fridayTeacher;
    }

    public String getClassName() {
        return className;
    }

    public void setClassName(String className) {
        this.className = className;
    }

    public String getSchoolName() {
        return schoolName;
    }

    public void setSchoolName(String schoolName) {
        this.schoolName = schoolName;
    }

    public String getGradeName() {
        return gradeName;
    }

    public void setGradeName(String gradeName) {
        this.gradeName = gradeName;
    }

    @Override
    public String toString() {
        return "Curriculum{" +
                "curriculumId=" + curriculumId +
                ", schoolCode=" + schoolCode +
                ", schoolYear=" + schoolYear +
                ", semester=" + semester +
                ", grade=" + grade +
                ", classCode=" + classCode +
                ", classPeriod=" + classPeriod +
                ", mondayCurriculum=" + mondayCurriculum +
                ", tuesdayCurriculum=" + tuesdayCurriculum +
                ", wednesdayCurriculum=" + wednesdayCurriculum +
                ", thursdayCurriculum=" + thursdayCurriculum +
                ", fridayCurriculum=" + fridayCurriculum +
                ", createUser=" + createUser +
                ", updateUser=" + updateUser +
                ", createTime=" + createTime +
                ", updateTime=" + updateTime +
                ", yn=" + yn +
                ", mondayTeacher=" + mondayTeacher +
                ", tuesdayTeacher=" + tuesdayTeacher +
                ", wednesdayTeacher=" + wednesdayTeacher +
                ", thursdayTeacher=" + thursdayTeacher +
                ", fridayTeacher=" + fridayTeacher +
                ", className=" + className +
                ", schoolName=" + schoolName +
                ", gradeName=" + gradeName +
                "}";
    }
}
