package com.ipsa.learn.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 排课表
 * </p>
 *
 * @author 1079626511@qq.com
 * @since 2020-08-24
 */
@Data
public class CurriculumVo implements Serializable {

private static final long serialVersionUID=1L;

    /**
     * 主键id
     */
    @ApiModelProperty("主键id")
    private Long curriculumId;

    /**
     * 学校编码
     */
    @ApiModelProperty("学校编码")
    private String schoolCode;

    /**
     * 学年
     */
    @ApiModelProperty("学年")
    private String schoolYear;

    /**
     * 学期
     */
    @ApiModelProperty("学期")
    private String semester;

    /**
     * 年级
     */
    @ApiModelProperty("年级")
    private String grade;

    /**
     * 班级
     */
    @ApiModelProperty("班级")
    private String classCode;

    /**
     * 课节
     */
    @ApiModelProperty("课节")
    private String classPeriod;

    /**
     * 周一课程
     */
    @ApiModelProperty("周一课程")
    private CurriculumNo mondayCurriculum;

    /**
     * 周二课程
     */
    @ApiModelProperty("周二课程")
    private CurriculumNo tuesdayCurriculum;

    /**
     * 周三课程
     */
    @ApiModelProperty("周三课程")
    private CurriculumNo wednesdayCurriculum;

    /**
     * 周四课程
     */
    @ApiModelProperty("周四课程")
    private CurriculumNo thursdayCurriculum;

    /**
     * 周五课程
     */
    @ApiModelProperty("周五课程")
    private CurriculumNo fridayCurriculum;

    /**
     * 创建人
     */
    @ApiModelProperty("创建人")
    private String createUser;

    /**
     * 修改人
     */
    @ApiModelProperty("修改人")
    private String updateUser;

    /**
     * 创建时间
     */
    @ApiModelProperty("创建时间")
    private LocalDateTime createTime;

    /**
     * 修改时间
     */
    @ApiModelProperty("修改时间")
    private LocalDateTime updateTime;

    /**
     * 0是删除 1正常
     */
    @ApiModelProperty("0是删除 1正常")
    private Integer yn;




    @Override
    public String toString() {
        return "Curriculum{" +
        "curriculumId=" + curriculumId +
        ", schoolCode=" + schoolCode +
        ", schoolYear=" + schoolYear +
        ", semester=" + semester +
        ", grade=" + grade +
        ", classCode=" + classCode +
        ", classPeriod=" + classPeriod +
        ", mondayCurriculum=" + mondayCurriculum +
        ", tuesdayCurriculum=" + tuesdayCurriculum +
        ", wednesdayCurriculum=" + wednesdayCurriculum +
        ", thursdayCurriculum=" + thursdayCurriculum +
        ", fridayCurriculum=" + fridayCurriculum +
        ", createUser=" + createUser +
        ", updateUser=" + updateUser +
        ", createTime=" + createTime +
        ", updateTime=" + updateTime +
        ", yn=" + yn +
        "}";
    }
}
