package com.ipsa.learn.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 选修课报名
 * </p>
 *
 * @author 1079626511@qq.com
 * @since 2020-08-24
 */
@Data
@TableName("elective_enroll")
public class ElectiveEnroll implements Serializable {

private static final long serialVersionUID=1L;

    /**
     * 主键id
     */
    @TableId(value = "elective_enroll_id", type = IdType.AUTO)
    @ApiModelProperty("主键id")
    private Long electiveEnrollId;

    /**
     * 学校编码
     */
    @ApiModelProperty("学校编码")
    private String schoolCode;

    /**
     * 选修课ID
     */
    @ApiModelProperty("选修课ID")
    private String courseId;

    /**
     * 班级
     */
    @ApiModelProperty("班级")
    private String classCode;

    /**
     * 学号
     */
    @ApiModelProperty("学号")
    private String studentNumbe;

    /**
     * 姓名
     */
    @ApiModelProperty("姓名")
    private String studentName;

    /**
     * 创建人
     */
    @ApiModelProperty("创建人")
    private String createUser;

    /**
     * 修改人
     */
    @ApiModelProperty("修改人")
    private String updateUser;

    /**
     * 创建时间
     */
    @ApiModelProperty("创建时间")
    private LocalDateTime createTime;

    /**
     * 报名时间string
     */
    @TableField(exist = false)
    @ApiModelProperty("报名时间String")
    private String stringCreateTime;

    /**
     * 修改时间
     */
    @ApiModelProperty("修改时间")
    private LocalDateTime updateTime;

    /**
     * 0是删除 1正常
     */
    @ApiModelProperty("0是删除 1正常")
    private Integer yn;

    /**
     * 学生Id
     */
    private String studentId;

    /**
     * 年级编码
     */
    private String grade;

    /**
     * 年级名称
     */
    private String gradeName;

    /**
     * 班级名称
     */
    private String className;

    public String getStringCreateTime() {
        return stringCreateTime;
    }

    public void setStringCreateTime(String stringCreateTime) {
        this.stringCreateTime = stringCreateTime;
    }

    public String getStudentId() {
        return studentId;
    }

    public void setStudentId(String studentId) {
        this.studentId = studentId;
    }

    public String getGrade() {
        return grade;
    }

    public void setGrade(String grade) {
        this.grade = grade;
    }

    public String getGradeName() {
        return gradeName;
    }

    public void setGradeName(String gradeName) {
        this.gradeName = gradeName;
    }

    public String getClassName() {
        return className;
    }

    public void setClassName(String className) {
        this.className = className;
    }

    public Long getElectiveEnrollId() {
        return electiveEnrollId;
    }

    public void setElectiveEnrollId(Long electiveEnrollId) {
        this.electiveEnrollId = electiveEnrollId;
    }

    public String getSchoolCode() {
        return schoolCode;
    }

    public void setSchoolCode(String schoolCode) {
        this.schoolCode = schoolCode;
    }

    public String getCourseId() {
        return courseId;
    }

    public void setCourseId(String courseId) {
        this.courseId = courseId;
    }

    public String getClassCode() {
        return classCode;
    }

    public void setClassCode(String classCode) {
        this.classCode = classCode;
    }

    public String getStudentNumbe() {
        return studentNumbe;
    }

    public void setStudentNumbe(String studentNumbe) {
        this.studentNumbe = studentNumbe;
    }

    public String getStudentName() {
        return studentName;
    }

    public void setStudentName(String studentName) {
        this.studentName = studentName;
    }

    public String getCreateUser() {
        return createUser;
    }

    public void setCreateUser(String createUser) {
        this.createUser = createUser;
    }

    public String getUpdateUser() {
        return updateUser;
    }

    public void setUpdateUser(String updateUser) {
        this.updateUser = updateUser;
    }

    public LocalDateTime getCreateTime() {
        return createTime;
    }

    public void setCreateTime(LocalDateTime createTime) {
        this.createTime = createTime;
    }

    public LocalDateTime getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(LocalDateTime updateTime) {
        this.updateTime = updateTime;
    }

    public Integer getYn() {
        return yn;
    }

    public void setYn(Integer yn) {
        this.yn = yn;
    }

    @Override
    public String toString() {
        return "ElectiveEnroll{" +
                "electiveEnrollId=" + electiveEnrollId +
                ", schoolCode='" + schoolCode + '\'' +
                ", courseId='" + courseId + '\'' +
                ", classCode='" + classCode + '\'' +
                ", studentNumbe='" + studentNumbe + '\'' +
                ", studentName='" + studentName + '\'' +
                ", createUser='" + createUser + '\'' +
                ", updateUser='" + updateUser + '\'' +
                ", createTime=" + createTime +
                ", stringCreateTime='" + stringCreateTime + '\'' +
                ", updateTime=" + updateTime +
                ", yn=" + yn +
                ", studentId='" + studentId + '\'' +
                ", grade='" + grade + '\'' +
                ", gradeName='" + gradeName + '\'' +
                ", className='" + className + '\'' +
                '}';
    }
}
