package com.ipsa.learn.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.google.common.collect.Maps;
import com.ipsa.learn.entity.CourseResultsupload;
import com.ipsa.learn.dao.CourseResultsuploadDao;
import com.ipsa.learn.entity.CourseResultsuploadDto;
import com.ipsa.learn.entity.ScheduleDto;
import com.ipsa.learn.service.CourseResultsuploadService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 考试上传 服务实现类
 * </p>
 *
 * @author 1079626511@qq.com
 * @since 2020-09-03
 */
@Slf4j
@Service
public class CourseResultsuploadServiceImpl extends ServiceImpl<CourseResultsuploadDao, CourseResultsupload> implements CourseResultsuploadService {

    @Autowired
    CourseResultsuploadService courseResultsuploadService;

    @Override
    public CourseResultsupload getCourseResultsupload(CourseResultsupload courseResultsupload) {
        LambdaQueryWrapper<CourseResultsupload> queryWrapper = new LambdaQueryWrapper<>();
        //学校编码
        if (StringUtils.isNotEmpty(courseResultsupload.getSchoolCode())){
            queryWrapper.eq(CourseResultsupload::getSchoolCode,courseResultsupload.getSchoolCode());
        }
        //学年
        if (StringUtils.isNotEmpty(courseResultsupload.getSchoolYear())){
            queryWrapper.eq(CourseResultsupload::getSchoolYear,courseResultsupload.getSchoolYear());
        }
        //学期
        if (StringUtils.isNotEmpty(courseResultsupload.getSemester())){
            queryWrapper.eq(CourseResultsupload::getSemester,courseResultsupload.getSemester());
        }
        //年级
        if (StringUtils.isNotEmpty(courseResultsupload.getGrade())){
            queryWrapper.eq(CourseResultsupload::getGrade,courseResultsupload.getGrade());
        }
        //班级
        if (StringUtils.isNotEmpty(courseResultsupload.getClassCode())){
            queryWrapper.eq(CourseResultsupload::getClassCode,courseResultsupload.getClassCode());
        }
        //科目名称
        if (StringUtils.isNotEmpty(courseResultsupload.getClassSubname())){
            queryWrapper.eq(CourseResultsupload::getClassSubname,courseResultsupload.getClassSubname());
        }
        //考试日期
        if (null != courseResultsupload.getTestdateTime()){
            queryWrapper.eq(CourseResultsupload::getTestdateTime,courseResultsupload.getTestdateTime());
        }
        //考试名称
        if (StringUtils.isNotEmpty(courseResultsupload.getTestdateName())){
            queryWrapper.eq(CourseResultsupload::getTestdateName,courseResultsupload.getTestdateName());
        }
        queryWrapper.eq(CourseResultsupload::getYn,1);
        CourseResultsupload one = courseResultsuploadService.getOne(queryWrapper);
        return one;
    }

    @Override
    public List<String> getTestNameList(CourseResultsupload courseResultsupload) {
        LambdaQueryWrapper<CourseResultsupload> queryWrapper = new LambdaQueryWrapper<>();
        //学校编码
        if (StringUtils.isNotEmpty(courseResultsupload.getSchoolCode())){
            queryWrapper.eq(CourseResultsupload::getSchoolCode,courseResultsupload.getSchoolCode());
        }
        //学年
        if (StringUtils.isNotEmpty(courseResultsupload.getSchoolYear())){
            queryWrapper.eq(CourseResultsupload::getSchoolYear,courseResultsupload.getSchoolYear());
        }
        //学期
        if (StringUtils.isNotEmpty(courseResultsupload.getSemester())){
            queryWrapper.eq(CourseResultsupload::getSemester,courseResultsupload.getSemester());
        }
        //年级
        if (StringUtils.isNotEmpty(courseResultsupload.getGrade())){
            queryWrapper.eq(CourseResultsupload::getGrade,courseResultsupload.getGrade());
        }
        //班级
        if (StringUtils.isNotEmpty(courseResultsupload.getClassCode())){
            queryWrapper.eq(CourseResultsupload::getClassCode,courseResultsupload.getClassCode());
        }
        queryWrapper.eq(CourseResultsupload::getYn,1);
        List<CourseResultsupload> list = courseResultsuploadService.list(queryWrapper);
        List<String> strings = new ArrayList<>();
        for (CourseResultsupload resultsupload : list) {
            if (StringUtils.isNotEmpty(resultsupload.getTestdateName())){
                strings.add(resultsupload.getTestdateName());
            }
        }
        return strings;
    }

    @Override
    public List<CourseResultsupload> getResultsPublishList(CourseResultsuploadDto courseResultsuploadDto) {
        LambdaQueryWrapper<CourseResultsupload> queryWrapper = new LambdaQueryWrapper<>();
        //学校编号
        if (StringUtils.isNotEmpty(courseResultsuploadDto.getSchoolCode())) {
            queryWrapper.eq(CourseResultsupload::getSchoolCode, courseResultsuploadDto.getSchoolCode());
        }
        //年级编号
        if (StringUtils.isNotEmpty(courseResultsuploadDto.getGrade())) {
            queryWrapper.eq(CourseResultsupload::getGrade, courseResultsuploadDto.getGrade());
        }
        //班级编号
        if (StringUtils.isNotEmpty(courseResultsuploadDto.getClassCode())) {
            queryWrapper.eq(CourseResultsupload::getClassCode, courseResultsuploadDto.getClassCode());
        }
        //学年
        if (StringUtils.isNotEmpty(courseResultsuploadDto.getSchoolYear())){
            queryWrapper.eq(CourseResultsupload::getSchoolYear,courseResultsuploadDto.getSchoolYear());
        }
        //学期
        if (StringUtils.isNotEmpty(courseResultsuploadDto.getSemester())){
            queryWrapper.eq(CourseResultsupload::getSemester,courseResultsuploadDto.getSemester());
        }
        //科目名称
        if (StringUtils.isNotEmpty(courseResultsuploadDto.getClassSubname())){
            queryWrapper.eq(CourseResultsupload::getClassSubname,courseResultsuploadDto.getClassSubname());
        }
        //考试日期
        if (null != courseResultsuploadDto.getTestdateTime()){
            queryWrapper.eq(CourseResultsupload::getTestdateTime,courseResultsuploadDto.getTestdateTime());
        }
        //考试名称
        if (StringUtils.isNotEmpty(courseResultsuploadDto.getTestdateName())){
            queryWrapper.eq(CourseResultsupload::getTestdateName,courseResultsuploadDto.getTestdateName());
        }
        //是否发布
        if (courseResultsuploadDto.getIsPublish() != null) {
            queryWrapper.eq(CourseResultsupload::getIsPublish, courseResultsuploadDto.getIsPublish());
        }
        //是否删除
        queryWrapper.eq(CourseResultsupload::getYn,1);

        return courseResultsuploadService.list(queryWrapper);
    }

    @Override
    public Map<String, Object> updateResultsPublishStatus(Long courseResultsuploadId) {
        CourseResultsupload courseResultsupload = courseResultsuploadService.getById(courseResultsuploadId);
        courseResultsupload.setIsPublish(1);
        courseResultsupload.setUpdateTime(LocalDateTime.now());
        Map<String, Object> map = Maps.newHashMap();
        if (courseResultsuploadService.updateById(courseResultsupload)) {
            map.put("flag", true);
            map.put("msg", "修改成绩发布状态成功");
            return map;
        }
        map.put("flag", false);
        map.put("msg", "修改成绩发布状态失败");
        return map;
    }

}
