package com.ipsa.learn.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.ipsa.learn.dao.CourseScoreDao;
import com.ipsa.learn.entity.*;
import com.ipsa.learn.service.CourseResultlistService;
import com.ipsa.learn.service.CourseResultsuploadService;
import com.ipsa.learn.service.CourseScoreService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ipsa.learn.util.*;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.List;

/**
 * <p>
 * 科目分数表 服务实现类
 * </p>
 *
 * @author 1079626511@qq.com
 * @since 2020-09-03
 */
@Slf4j
@Service
public class CourseScoreServiceImpl extends ServiceImpl<CourseScoreDao, CourseScore> implements CourseScoreService {

    @Autowired
    CourseResultsuploadService courseResultsuploadService;

    @Autowired
    CourseScoreService courseScoreService;

    @Autowired
    CourseResultlistService courseResultlistService;

    @Override
    public String uploadExcels(MultipartFile file, CourseResultsuploadVo courseResultsupload) {
        try {
            String excelInfo02 = new ReadExcel02().getExcelInfo02(file);
            //将成绩相关的数据添加
            if (null != courseResultsupload.getCourseResultsuploadId()){
                CourseResultsupload courseResultsupload1 = courseResultsuploadService.getById(courseResultsupload.getCourseResultsuploadId());
                if (!excelInfo02.contains(courseResultsupload1.getClassSubname())){
                    return "上传成绩的科目名称与Excel种的科目名称不匹配";
                }
                List<CourseScore> courseScoreList = getCourseScoreList(String.valueOf(courseResultsupload.getCourseResultsuploadId()));
                if (courseScoreList != null || courseScoreList.size()>0){
                    for (CourseScore courseScore : courseScoreList) {
                        courseScore.setYn(0);
                        courseScoreService.updateById(courseScore);
                    }
                    String saveCourseScore = getSaveCourseScore(file, courseResultsupload1);
                    return saveCourseScore;
                }else {
                    String saveCourseScore = getSaveCourseScore(file, courseResultsupload1);
                    return saveCourseScore;
                }
            }else {
                if (!excelInfo02.contains(courseResultsupload.getClassSubname())){
                    return "上传成绩的科目名称与Excel中的科目名称不匹配";
                }
                String testdateTimeName = courseResultsupload.getTestdateTimeName();
                LocalDateTime startDateTime =
                        LocalDateTime.parse(testdateTimeName+" 00:00:00", DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));
                courseResultsupload.setTestdateTime(startDateTime);

                String subNames = courseResultsupload.getClassSubname();
                String[] split = subNames.split(",");
                for (String subName : split) {
                    courseResultsupload.setClassSubname(subName);

                    CourseResultsupload courseResultsupload1 = courseResultsuploadService.getCourseResultsupload(courseResultsupload);
                    if (null != courseResultsupload1){
                        Long courseResultsuploadId = courseResultsupload1.getCourseResultsuploadId();
                        List<CourseScore> courseScoreList = getCourseScoreList(String.valueOf(courseResultsuploadId));
                        if (courseScoreList != null || courseScoreList.size()>0){
                            for (CourseScore courseScore : courseScoreList) {
                                courseScore.setYn(0);
                                courseScoreService.updateById(courseScore);
                            }
                            String saveCourseScore = getSaveCourseScore(file, courseResultsupload1);
                            //return saveCourseScore;
                        }else {
                            String saveCourseScore = getSaveCourseScore(file, courseResultsupload1);
                            //return saveCourseScore;
                        }
                    }else {
                        //多科目上传
                        courseResultsuploadService.save(courseResultsupload);
                        getSaveCourseScore2(file, courseResultsupload);
                        //return "添加成功";
                    }
                }

                return "添加成功";

            }
        } catch (Exception e) {
            e.printStackTrace();
            return "添加失败";
        }
    }

    private String getSaveCourseScore(MultipartFile file,CourseResultsupload courseResultsupload){
        Long courseResultsuploadId = courseResultsupload.getCourseResultsuploadId();  //成绩上传的id
        //创建处理EXCEL的类
        ReadExcel01 readExcel = new ReadExcel01();
        List<CourseScore> curriculumList = readExcel.getExcelInfo(file);
        log.info("*****Excel导入的数据curriculumList****，:{}",curriculumList.toString());
        if (curriculumList.size() == 0 || curriculumList == null){
            return "导入的数据为空";
        }
        for (CourseScore courseScore : curriculumList) {
            CourseScore courseScore1 = new CourseScore();
            courseScore1.setStudentUserId(courseScore.getStudentUserId()); //学生Id
            courseScore1.setStudentNo(courseScore.getStudentNo());  //学生编号
            courseScore1.setStudentUserName(courseScore.getStudentUserName());  //学生名称
            courseScore1.setSubjectsScores(courseScore.getSubjectsScores());  //科目的分数
            courseScore1.setCourseResultsuploadId(String.valueOf(courseResultsuploadId));  //成绩上传的id
            courseScore1.setCreateUser(courseResultsupload.getCreateUser());   //创建人
            courseScore1.setSubjectsName(courseResultsupload.getClassSubname()); //科目名称
            courseScore1.setYn(1);
            String subjectsOptimal = getSubjectsOptimal(courseScore.getSubjectsScores());
            courseScore1.setSubjectsOptimal(subjectsOptimal);
            //添加成绩相关的分数
            courseScoreService.save(courseScore1);
        }
        List<CourseResultlist> courseResult = courseResultlistService.getCourseResult(String.valueOf(courseResultsuploadId));
        if (courseResult != null || courseResult.size()>0){
            for (CourseResultlist courseResultlist : courseResult) {
                courseResultlist.setYn(0);
                courseResultlistService.updateById(courseResultlist);
            }
        }
        CourseResultlist countSum = courseResultlistService.getCountSum(String.valueOf(courseResultsuploadId));
        //记录班级成绩列表
        if (countSum != null){
            countSum.setGrade(courseResultsupload.getGrade());
            countSum.setGradeName(courseResultsupload.getGradeName());
            countSum.setClassCode(courseResultsupload.getClassCode());
            countSum.setClassName(courseResultsupload.getClassName());
            countSum.setCourseResultsuploadId(String.valueOf(courseResultsuploadId));
            countSum.setSubjectsName(courseResultsupload.getClassSubname());  //科目名称
            countSum.setTestdateName(courseResultsupload.getTestdateName());  //考试名称
            if (countSum.getOnaverageResults() != null){
                countSum.setSubjectsOptimal(getSubjectsOptimal(countSum.getOnaverageResults()));
            }
            String onaverageResults = countSum.getOnaverageResults();//平均成绩
            if (StringUtils.isNotEmpty(onaverageResults)){
                double v = Double.parseDouble(onaverageResults);
                double ceil = Math.ceil(v);
                String s = String.valueOf(ceil);
                countSum.setOnaverageResults(s); //向上取整
            }
            countSum.setCreateUser(courseResultsupload.getCreateUser());
            countSum.setYn(1);
            courseResultlistService.save(countSum);
        }
        return "添加成功";
    }
    private String getSaveCourseScore2(MultipartFile file,CourseResultsupload courseResultsupload){
        Long courseResultsuploadId = courseResultsupload.getCourseResultsuploadId();  //成绩上传的id
        //创建处理EXCEL的类
        ReadExcel01 readExcel = new ReadExcel01();
        List<CourseScore> curriculumList = readExcel.getExcelInfo2(file, courseResultsupload.getClassSubname());
        log.info("*****Excel导入的数据curriculumList****，:{}",curriculumList.toString());
        if (curriculumList.size() == 0 || curriculumList == null){
            return "导入的数据为空";
        }
        for (CourseScore courseScore : curriculumList) {
            CourseScore courseScore1 = new CourseScore();
            courseScore1.setStudentUserId(courseScore.getStudentUserId()); //学生Id
            courseScore1.setStudentNo(courseScore.getStudentNo());  //学生编号
            courseScore1.setStudentUserName(courseScore.getStudentUserName());  //学生名称
            courseScore1.setSubjectsScores(courseScore.getSubjectsScores());  //科目的分数
            courseScore1.setCourseResultsuploadId(String.valueOf(courseResultsuploadId));  //成绩上传的id
            courseScore1.setCreateUser(courseResultsupload.getCreateUser());   //创建人
            courseScore1.setSubjectsName(courseResultsupload.getClassSubname()); //科目名称
            courseScore1.setYn(1);
            String subjectsOptimal = getSubjectsOptimal(courseScore.getSubjectsScores());
            courseScore1.setSubjectsOptimal(subjectsOptimal);
            //添加成绩相关的分数
            courseScoreService.save(courseScore1);
        }
        List<CourseResultlist> courseResult = courseResultlistService.getCourseResult(String.valueOf(courseResultsuploadId));
        if (courseResult != null || courseResult.size()>0){
            for (CourseResultlist courseResultlist : courseResult) {
                courseResultlist.setYn(0);
                courseResultlistService.updateById(courseResultlist);
            }
        }
        CourseResultlist countSum = courseResultlistService.getCountSum(String.valueOf(courseResultsuploadId));
        //记录班级成绩列表
        if (countSum != null){
            countSum.setGrade(courseResultsupload.getGrade());
            countSum.setGradeName(courseResultsupload.getGradeName());
            countSum.setClassCode(courseResultsupload.getClassCode());
            countSum.setClassName(courseResultsupload.getClassName());
            countSum.setCourseResultsuploadId(String.valueOf(courseResultsuploadId));
            countSum.setSubjectsName(courseResultsupload.getClassSubname());  //科目名称
            countSum.setTestdateName(courseResultsupload.getTestdateName());  //考试名称
            if (countSum.getOnaverageResults() != null){
                countSum.setSubjectsOptimal(getSubjectsOptimal(countSum.getOnaverageResults()));
            }
            String onaverageResults = countSum.getOnaverageResults();//平均成绩
            if (StringUtils.isNotEmpty(onaverageResults)){
                double v = Double.parseDouble(onaverageResults);
                double ceil = Math.ceil(v);
                String s = String.valueOf(ceil);
                countSum.setOnaverageResults(s); //向上取整
            }
            countSum.setCreateUser(courseResultsupload.getCreateUser());
            countSum.setYn(1);
            courseResultlistService.save(countSum);
        }
        return "添加成功";
    }

    private List<CourseScore> getCourseScoreList(String courseResultsuploadId){
        LambdaQueryWrapper<CourseScore> queryWrapper = new LambdaQueryWrapper<>();
        queryWrapper.eq(CourseScore::getCourseResultsuploadId,courseResultsuploadId);
        List<CourseScore> scoreList = courseScoreService.list(queryWrapper);
        return scoreList;
    }

    public String getSubjectsOptimal(String score){
        //long parseLong = Long.parseLong(score);
        double parseLong = Double.parseDouble(score);
        String scores = "";
        if (100>= parseLong && parseLong >= 85){
            scores = "优秀";
        }else if (85> parseLong && parseLong >=75){
            scores = "良好";
        }else if (75> parseLong && parseLong >= 60){
            scores = "及格";
        }else if (60> parseLong){
            scores = "不及格";
        }else {
            scores = "成绩录入有误";
        }
        return scores;
    }

    @Override
    public List<CourseScoreHistory> getHistory(CourseScoreHistoryRequest request) {
        return baseMapper.selectHistory(request);
    }

}
