package com.ipsa.learn.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ipsa.learn.dao.ElectiveCourseDao;
import com.ipsa.learn.entity.ElectiveCourse;
import com.ipsa.learn.entity.ElectiveCourseDto;
import com.ipsa.learn.entity.ElectiveEnroll;
import com.ipsa.learn.entity.ScheduleDto;
import com.ipsa.learn.service.ElectiveCourseService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 选修课排课 服务实现类
 * </p>
 *
 * @author 1079626511@qq.com
 * @since 2020-08-24
 */
@Service
public class ElectiveCourseServiceImpl extends ServiceImpl<ElectiveCourseDao, ElectiveCourse> implements ElectiveCourseService {

    @Autowired
    ElectiveCourseDao electiveCourseDao;

    @Override
    public List<ElectiveCourseDto> getCourseEnrollList(ScheduleDto electiveEnroll) {
        List<ElectiveCourseDto> courseEnrollList = electiveCourseDao.getCourseEnrollList(electiveEnroll);
        for (ElectiveCourseDto electiveCourseDto : courseEnrollList) {
            if (StringUtils.isNotEmpty(electiveCourseDto.getElectiveEnrollId())){
                electiveCourseDto.setGn("02");
            }else {
                electiveCourseDto.setGn("01");
            }
        }
        return courseEnrollList;
    }
}
