package com.ipsa.learn.util;

import com.baomidou.mybatisplus.core.enums.IEnum;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;

public enum ChooseStatus implements IEnum<Integer> {
    TOASH(0, "刪除"),
    NORMAL(1, "正常"),
    ;

    private Integer value;

    private String status;

    @Override
    public Integer getValue() {
        return this.value;
    }

    private ChooseStatus(Integer value, String status){
        this.value = value;
        this.status = status;
    }

    public static LinkedHashMap<Integer, String> getMap(){
        LinkedHashMap<Integer, String> root = new LinkedHashMap<>();
        for (CheckStatus e : CheckStatus.values()) {
            root.put(e.getValue(), e.getStatus());
        }
        return root;
    }

    public static List<CheckStatus> getList(){
        List<CheckStatus> checkStatuses = new ArrayList<>();
        for (CheckStatus e : CheckStatus.values()) {
            checkStatuses.add(e);
        }
        return checkStatuses;
    }

    public void setValue(Integer value) {
        this.value = value;
    }

    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    public static void main(String[] args) {

    }
}
