package com.ipsa.learn.util;

/**
 * @author mowei
 *         系统常量存放位置
 */
public class Constants {

    // 正常
    public static final String ZHENGCHANG = "00";
    // 代课
    public static final String DAIKE = "01";
    // 调课
    public static final String TIAOKE = "02";

    // 验证码
    public static final String SESSION_CAPTCHA = "session.captcha_";

    // 注册手机以及手机找回密码session
    public static final String SESSION_MOBILE = "session.mobile_";

    // 注册时用户实体session
    public static final String SESSION_MEMBER = "session.member_";

    // 用户名称session
    public static final String SESSION_USER_NAME = "session.user.name_";

    // 防止篡改form的随机数的session
    public static final String SESSION_FORM_RAMDOM = "session.form.ramdom_";

    // form随机数参数名称
    public static final String FORM_RAMDOM_PARAMETER = "_LHLYJGKH_";

    // 条件“与”
    public static final String RELATION_AND = "and";

    // 条件“或”
    public static final String RELATION_OR = "or";

    // 自定义配置文件
    public static final String ENVIRONMENT_PROPERTIES_PATH = "config.properties";

    // 系统目前所设置的主题变量，默认为空，当系统启动时(去数据库查询其当前所属主题类别)/任务自动时令切换/手动切换，修改其值（1：冬；2：夏）
    public static String SYSTEM_RIGHT_THEME = "";

    // 上传文件类型
    public static final String ATTACHMENT_TYPE_IMAGE = "image";
    public static final String ATTACHMENT_TYPE_DOCUMENT = "document";
    public static final String ATTACHMENT_TYPE_OTHER = "other";

    // 数据类型
    public static final String DATA_TYPE_FLOAT = "float";
    public static final String DATA_TYPE_DOUBLE = "double";
    public static final String DATA_TYPE_STRING = "string";
    public static final String DATA_TYPE_DATE = "date";
    public static final String DATA_TYPE_DATE_TIME = "datetime";
    public static final String DATA_TYPE_XML = "xml";
    public static final String DATA_TYPE_JSON = "json";

    // 启禁用标志： 0：禁用 1：启用
    public static final String ISUSE_FLAG_CLOSE = "0";
    public static final String ISUSE_FLAG_OPEN = "1";

    // 性别标志：性别:0、女 1、男
    public static final String SEX_FLAG_WOMEN = "0";
    public static final String SEX_FLAG_MEN = "1";

    // 用户类型：用户类型（0：会员，1：代理商，2：系统用户(客服)，3：VIP会员，4：系统生成用户(代客下单时生成新用户)）
    public static final String USER_TYPE_MEMBER = "0";
    public static final String USER_TYPE_AGENT = "1";
    public static final String USER_TYPE_SYS = "2";
    public static final String USER_TYPE_VIP = "3";
    public static final String USER_TYPE_SYSFORVALET = "4";

    // 是否匿名（0：否，1：是）
    public static final String ANONYMITY_NO = "0";
    public static final String ANONYMITY_YES = "1";

    // 产品类型(0：酒店x，1：休闲娱乐，2：餐饮x，3：组合产品x，4：亲子游(优惠活动)，5:滑雪卡，6:房型(前台不显示)，7：双人游x，8：会员定制，9：度假卡，P：票务)
    public static final String PRODUCT_TYPE_HOTEL = "0";
    public static final String PRODUCT_TYPE_PLAY = "1";
    public static final String PRODUCT_TYPE_FOOD = "2";
    public static final String PRODUCT_TYPE_DIY = "3";
    public static final String PRODUCT_TYPE_CUSTOM = "4";
    public static final String PRODUCT_TYPE_SKIING = "5";
    public static final String PRODUCT_TYPE_ROOM = "6";
    public static final String PRODUCT_TYPE_DOUBLE = "7";
    public static final String PRODUCT_TYPE_MERGER = "8";
    public static final String PRODUCT_TYPE_CARD = "9";
    public static final String PRODUCT_TYPE_TICKET = "P";

    // 是否特卖产品
    public static final String PRODUCT_SPECIAL_NO = "0";
    public static final String PRODUCT_SPECIAL_YES = "1";

    // 是否需要客服确认(0：不确认 1：确认)
    public static final String CONFIRM_NO = "0";
    public static final String CONFIRM_YES = "1";

    // 产品状态(0：待审核，1：已上架，2：已下架，3：已过期)
    public static final String PRODUCT_STATE_EXAMINE = "0";
    public static final String PRODUCT_STATE_UP = "1";
    public static final String PRODUCT_STATE_DOWN = "2";
    public static final String PRODUCT_STATE_OLD = "3";

    // 促销类型
    public static final String PROMOTIONS_TYPE_PRODUCT = "promotionsProduct";
    public static final String PROMOTIONS_TYPE_TITLE = "promotionTitle";

    // 促销状态(0：未发布，1：已发布，2：已过期)promotionState
    public static final String PRODUCT_PROMOTION_STATE_EXAMINE = "0";
    public static final String PRODUCT_PROMOTION_STATE_PUBLISH = "1";
    public static final String PRODUCT_PROMOTION_STATE_OLD = "2";

    // 是否首页促销区推荐(0：不推荐，1：推荐)
    public static final String PROMOTION_NO = "0";
    public static final String PROMOTION_YES = "1";

    // 是否代理商专属（0：否，1：是）
    public static final String AGENT_ONLY_NO = "0";
    public static final String AGENT_ONLY_YES = "1";

    // 操作类型（0：新建/修改，1：上架，2：下架，3：促销）
    public static final String OPERATE_TYPE_ADD_OR_MODIFY = "0";
    public static final String OPERATE_TYPE_UP = "1";
    public static final String OPERATE_TYPE_DOWN = "2";
    public static final String OPERATE_TYPE_PROMOTION = "3";

    // 订单状态（0：待确认 1：已确认 2：待退款 3：已取消）
    public static final String ORDER_STATE_NEW = "0";
    public static final String ORDER_STATE_SUCCESS = "1";
    public static final String ORDER_STATE_WAIT_CANCEL = "2";
    public static final String ORDER_STATE_HAVE_CANCEL = "3";

    // 支付状态（0：未支付 1：已支付 2：待退款 3：已退款）
    public static final String PAY_STATE_NO_PAY = "0";
    public static final String PAY_STATE_HAVE_PAY = "1";
    public static final String PAY_STATE_WAIT_REFUND = "2";	// not use
    public static final String PAY_STATE_HAVGE_REFUND = "3";

    // 支付类型（0：支付，1：退款）
    public static final String PAY_TYPE_PAY = "0";
    public static final String PAY_TYPE_REFUND = "1";

    // 支付方式（0：支付宝，1：度假卡，2：银联）
    public static final String PAY_MODE_ALIPAY = "0";
    public static final String PAY_MODE_HOLIDAY_CARD = "1";
    public static final String PAY_MODE_CHINA_PAY = "2";

    // 是否绑定度假卡0(未绑定)，1(已绑定)
    public static final String BOUND_HOLIDAY_CARD_NO = "0";
    public static final String BOUND_HOLIDAY_CARD_YES = "1";

    // 日志类型（0：登陆 1：登出 2：系统管理 3：会员管理 4：订单管理 5：代理商管理 6:促销管理
    // 7：报表管理8：系统当前主题设置9：系统度假项目/酒店设施）
    public static final String LOG_TYPE_LOGIN = "0";
    public static final String LOG_TYPE_LOGOUT = "1";
    public static final String LOG_TYPE_SYSTEM = "2";
    public static final String LOG_TYPE_MEMBER = "3";
    public static final String LOG_TYPE_ORDER = "4";
    public static final String LOG_TYPE_AGENT = "5";
    public static final String LOG_TYPE_PROMOTION = "6";
    public static final String LOG_TYPE_RECORD = "7";
    public static final String LOG_TYPE_THEME = "8";
    public static final String LOG_TYPE_VPHF = "9";

    // 代理商状态(0：待审核、1：已审核、2：已取消、3：已过期)
    public static final String AGENT_STATE_CHECKPENDING = "0";
    public static final String AGENT_STATE_AUDITED = "1";
    public static final String AGENT_STATE_CANCELED = "2";
    public static final String AGENT_STATE_SENIOR = "3";

    // 用户初始密码
    public static final String INIT_PASSWORD = "000000";

    // 超级管理员用户id/角色id/菜单id/
    public static final long SUPERVISOR_ID = 1;

    // 未登录时的用户名
    public static final String USER_NAME_NOT_LOGIN = "anonymousUser";

    // 角色类型 前台会员角色：ROLE_MEMBER 前台代理商角色：ROLE_AGENT 未登录角色：ROLE_ANONYMOUS
    public static final String PORTAL_USER_ROLE_MEMBER = "ROLE_MEMBER";
    public static final String PORTAL_USER_ROLE_AGENT = "ROLE_AGENT";
    public static final String PORTAL_USER_ROLE_ANONYMOUS = "ROLE_ANONYMOUS";

    // 数据库字典表标示
    public static final String SYS_DICTIONARY_PRODUCT_TYPE = "product_type";
    public static final String SYS_DICTIONARY_LINK_CHANNEL = "link_channel";
    public static final String SYS_DICTIONARY_ORDER_STATE = "order_state";
    public static final String SYS_DICTIONARY_PAY_STATE = "pay_state";
    public static final String SYS_DICTIONARY_COPYWRITING_CODE = "copywriting_code";
    public static final String SYS_DICTIONARY_ISUSE_FLAG = "isuse_flag";
    public static final String SYS_DICTIONARY_BOUND_CARD_STATE = "bound_card_state";
    public static final String SYS_DICTIONARY_PAY_MODE = "pay_mode";

    // 定时器中的job名称
    public static final String SYS_JOB_REMINDER_ORDER_NODE = "NODE_R";// 订单的短信提醒
    public static final String SYS_JOB_REMINDER_ORDER_CANCEL = "ORDER_C";// 订单取消
    public static final String SYS_JOB_REMINDER_PRODUCT = "PRODUCT_R";// 产品提醒

    // 代理商账号的状态0(待审核)，1(已审核)，2(已取消)，3(已过期)
    public static final String AGENT_STATE_EXAMINE = "0";
    public static final String AGENT_STATE_UP = "1";
    public static final String AGENT_STATE_DOWN = "2";
    public static final String AGENT_STATE_OLD = "3";

    // 页面来源： 注册：register 忘记密码：forgetPwd
    public static final String PAGE_FROM_TYPE_REGISTER = "register";
    public static final String PAGE_FROM_TYPE_FORGETPWD = "forgetPwd";

    // 系统 servlet命令标示
    public static final String SYSTEM_SERVLET_COMMAND = "_COMMAND_";

    // 返回标示（0：失败，1：成功）
    public static final String RETURN_STATUS_FAIL = "0";
    public static final String RETURN_STATUS_SUCCESS = "1";

    // 系统之间不同 servlet任务调用命令
    public static final String SYSTEM_SERVLET_COMMAND_CONNECT = "connect";
    public static final String SYSTEM_SERVLET_COMMAND_SENDMSG = "sendMsg";
    public static final String SYSTEM_SERVLET_COMMAND_UPDATE_CACHE = "updateCache";
    public static final String SYSTEM_SERVLET_COMMAND_UPDATE_CHANNELPAR = "updateChannelPar";
    public static final String SYSTEM_SERVLET_COMMAND_UPDATE_WEATHER = "updateWeather";
    public static final String SYSTEM_SERVLET_COMMAND_UPDATE_SERIES = "updateSeries";
    public static final String SYSTEM_SERVLET_COMMAND_UPDATE_SYSTHEMETYPE = "updateSysThemeType";
    public static final String SYSTEM_SERVLET_COMMAND_UPDATE_VPHF = "updateVpHf";

    // 短信验证码前后缀
    public static final String MSG_VERIFICATION_PREFIX = "msgVerificationPrefix";
    public static final String MSG_VERIFICATION_SUFFIX = "msgVerificationSuffix";

    // 定时器任务组名称
    public static final String JOB_GROUP_NAME = "CBS";

    // 报表格式(1：日报表、2：月报表、3：年报表、4：区间段)
    public static final String REPORT_MODE_DAY = "1";
    public static final String REPORT_MODE_MONTH = "2";
    public static final String REPORT_MODE_YEAR = "3";
    public static final String REPORT_MODE_REGION = "4";

    // 报表查询项(0：选择、1：渠道、2：地区、3：产品、4：广告位)
    public static final String REPORT_STATISTICS_TYPE_SELECT = "0";
    public static final String REPORT_STATISTICS_TYPE_CHANNEL = "1";
    public static final String REPORT_STATISTICS_TYPE_AREA = "2";
    public static final String REPORT_STATISTICS_TYPE_PRODUCT = "3";
    public static final String REPORT_STATISTICS_TYPE_AD = "4";

    // 会员报表统计项(注册会员,新增注册会员,消费会员,新增消费会员,登陆会员)
    public static final String REPORT_MEMBER_STATISTICS_ITEM = "zc,xzzc,xf,xzxf,dl";

    // 销售报表统计项(订单数，张数，金额)
    public static final String REPORT_SALE_STATISTICS_ITEM = "dds,zs,je";

    // cookies有效期一个月
    public static final Integer COOKIES_VALID_TIME = 60 * 60 * 24 * 31;

    // 优惠劵来源：优惠券来源(系统生成0，手机发送1,共享生成2,国航生成3,活动领取4)
    public static final String COUPON_FROM_TYPE_SYSTEM = "0";
    public static final String COUPON_FROM_TYPE_PHONE = "1";
    public static final String COUPON_FROM_TYPE_DATE = "2";
    public static final String COUPON_FROM_TYPE_CA = "3";
    public static final String COUPON_FROM_TYPE_RC = "4";

    // 优惠劵状态：(0未使用,1已使用,2已过期)
    public static final String COUPON_STATUS_NO_USE = "0";
    public static final String COUPON_STATUS_USED = "1";
    public static final String COUPON_STATUS_INVALID = "2";

    // 产品文案是否必选：是否必选（0：非必选,1：必选）
    public static final String PRODUCT_COPYWRITING_REQUIRED_NO = "0";
    public static final String PRODUCT_COPYWRITING_REQUIRED_YES = "1";

    // 产品文案类别（1：娱乐,2：餐饮,3：票务）
    public static final String PRODUCT_COPYWRITING_TYPE_PLAY = "1";
    public static final String PRODUCT_COPYWRITING_TYPE_EAT = "2";
    public static final String PRODUCT_COPYWRITING_TYPE_TICKET = "3";

    // 订单是否短信通知(0:否、1：是)
    public static final String IS_NOTE_INFORMED_NO = "0";
    public static final String IS_NOTE_INFORMED_YES = "1";

    // 前台推荐位置
    public static final String HOT_RECOMMEND = "0";// 热门推荐
    public static final String SHOPING_CAR_RECOMMEND = "1";// 购物车推荐
    public static final String STARRED_HOTEL = "2";// 精品酒店
    public static final String TOP_LEVEL_SKI = "3";// 顶级滑雪
    public static final String MOUNTAINTOP_LAKE = "4";// 天池
    public static final String SHAMAN_CULTURE = "5";// 萨满文化
    public static final String OUTDOORS = "6";// 山地户外
    public static final String HOTSPRING = "7";// 温泉
    public static final String ORIGINAL_SOUND_THEATRE = "8";// 原声剧院
    public static final String SHOPING_TOWN = "9";// 度假小镇
    public static final String HOLIDAYS_CARD = "10";// 度假卡推荐
    public static final String ITINERARY = "11";// 行程
    public static final String TRAVEL_NOTES = "12";// 游记
    public static final String HOLIDAYS_COLUMN = "13";// 度假专栏
    public static final String NOTICE = "14";// 度假专栏
    public static final String STRATEGY = "15";// 攻略
    public static final String SPECIALTY_CATERING = "16";// 特色餐饮
    public static final String NEARBY_ATTRACTIONS = "17";// 周围景点
    public static final String TRANSPORTATION = "18";// 交通
    public static final String VILLA_DISTRICT = "19";// 别墅区
    public static final String RECOMMENDED_ERR = "20";// 错误页面推荐

    // 前台推荐酒店
    public static final String HOTEL_POSITION = "0"; // 酒店

    // 产品系列最大数
    public static final int PRODUCT_SERIES_MAX_NUM = 7;

    // 是否可加床(0:否、1：是)
    public static final String ROOM_IS_ADD_BED_NO = "0";
    public static final String ROOM_IS_ADD_BED_YES = "1";

    // 是否单品(0:否、1：是)
    public static final String IS_SINGLE_NO = "0";
    public static final String IS_SINGLE_YES = "1";

    // 批量修改（modify）/批量新增（add）的标示
    public static final String INVENTORY_PRICE_MODIFY = "modify";
    public static final String INVENTORY_PRICE_ADD = "add";

    // 主题属性（0：所有；1：冬；2：夏）
    public static final String THEME_ATTRIBUTE_ALL = "0";
    public static final String THEME_ATTRIBUTE_WINTER = "1";
    public static final String THEME_ATTRIBUTE_SUMMER = "2";

    // 显示位置（0：所有；1：首页；2：社区互动）
    public static final String SHOW_POSITION_ALL = "0";
    public static final String SHOW_POSITION_HOME = "1";
    public static final String SHOW_POSITION_COMMUNITY = "2";

    // 社区类型（1：互动展示图；2：旅游攻略；3：推荐行程；4：热门游记)
    public static final String COMMUNITY_TYPE_SHOW = "1";
    public static final String COMMUNITY_TYPE_STRATEGY = "2";
    public static final String COMMUNITY_TYPE_PATH = "3";
    public static final String COMMUNITY_TYPE_TRAVELS = "4";

    // 度假主题（1：滑雪；2：高尔夫；3：山地越野)
    public static final String VACATION_THEME_SKI = "1";
    public static final String VACATION_THEME_GOLF = "2";
    public static final String VACATION_THEME_CROSS_COUNTRY = "3";

    // 度假项目（1：滑雪；2：高尔夫；3：射击；4：缆车；5：温泉；6：文化馆；7：山地越野)
    public static final String VACATION_ITEM_SKI = "1";
    public static final String VACATION_ITEM_GOLF = "2";
    public static final String VACATION_ITEM_SHOOT = "3";
    public static final String VACATION_ITEM_TELPHER = "4";
    public static final String VACATION_ITEM_HOTSPRING = "5";
    public static final String VACATION_ITEM_CULTURE = "6";
    public static final String VACATION_ITEM_CROSS_COUNTRY = "7";

    // 是否回复标志： 0：未回复 1：已回复
    public static final String REPLY_FLAG_CLOSE = "0";
    public static final String REPLY_FLAG_OPEN = "1";

    // 是否回复标志： 0：未发布 1：已发布
    public static final String RELEASE_FLAG_CLOSE = "0";
    public static final String RELEASE_FLAG_OPEN = "1";

    // 系统度假项目/酒店设施标志： 1：度假项目 2：酒店设施
    public static final String SYS_VPHF_FLAG_VP = "1";
    public static final String SYS_VPHF_FLAG_HF = "2";

    // 系统度假项目/酒店设施标志code前缀： vp：度假项目 hf：酒店设施
    public static final String SYS_VPHF_CODE_VP = "vp";
    public static final String SYS_VPHF_CODE_HF = "hf";

    // 产品项目属性CODE前缀（jd：产品包括酒店）
    public static final String SYS_PROJECT_CODE_JD = "jd";

    // 微博显示位置0、普通（没有显示位置）;1.首页 ;2社区; 3全部;
    public static final String SHOW_POSISTION_COMM = "0";
    public static final String SHOW_POSISTION_HOME = "1";
    public static final String SHOW_POSISTION_COMMUNITY = "2";
    public static final String SHOW_POSISTION_ALL = "3";

    // 前台促销产品显示位置（0：所有 1：首页促销 2：特别优惠 ）
    public static final String PROMOTION_POSITION_ALL = "0";
    public static final String PROMOTION_POSITION_HOME = "1";
    public static final String PROMOTION_POSITION_SPECIAL = "2";

    // 产品置顶标志（0：否；1：置顶）
    public static final String PRODUCT_IS_TOP_NO = "0";
    public static final String PRODUCT_IS_TOP_YES = "1";
    // 链接渠道 （guohang：国 航）
    public static final String LINKCHANNEL_GH = "guohang";
    public static final String CA = "CA";

    // 广告类型（0：产品；1：酒店）
    public static final String ADVERTISE_TYPE_PRODUCT = "0";
    public static final String ADVERTISE_TYPE_HOTEL = "1";
    // wap支付状态（1：未支付 2：已支付 3：已取消 ）（孙长俊添加）
    public static final String WAP_ORDER_STATE_NO_PAY = "1";
    public static final String WAP_ORDER_STATE_HAVE_PAY = "2";
    public static final String WAP_ORDER_STATE_CANCEL = "3";
    
    
    
    /**
     * 支付渠道
     * 0：支付宝
     * 1：银联
     * 2：财付通
     */
    public static final int PAY_CHANNEL_ZHIFUBAO = 0;
    public static final int PAY_CHANNEL_YINLIAN = 1;
    public static final int PAY_CHANNEL_CAIFUTONG = 2;
    // 来源
    public static final int WEIXIN_SOURCE = 1;
    public static final int PC_SOURCE = 2;
    // 微信渠道ID
    public static final String WEIXIN_CHANNELID = "2A6E812B-0386-4D0B-BA02-35AFB7F95BBF";

    //

    public static final String NAME_SPACE = "http://schemas.datacontract.org/2004/07/Wanda.CBS.BOPS.ViewModel";

    // 营销平台返回失败编码
    public static final String RESULT = "00000000-0000-0000-0000-000000000000";
}
