package com.ipsa.learn.util;

import org.apache.commons.lang3.StringUtils;

import java.sql.Timestamp;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.ParsePosition;
import java.text.SimpleDateFormat;
import java.util.*;


/**
 * <p>
 * Copyright © 2007 WEDOMO  All Rights Reserved.
 * </p>
 * <p>
 * WEDOMO Corp CONFIDENTIAL. All information, copyrights, trade secrets<br>
 * and other intellectual property rights, contained herein are the property<br>
 * of WEDOMO. This file is strictly confidential and must not be<br>
 * copied, accessed, disclosed or used in any manner, in whole or in part,<br>
 * without WEDOMO's express written authorization.
 * </p>
 */
public class DateUtils {
	
	public static String DATE_PARRTEN = "yyyy-MM-dd";
	public static String DATE_TIME_PARRTEN = "yyyy-MM-dd HH:mm:ss";

    public static long HALF_HOUR = 1800000;
    
    public static long HOUR = 3600000;
    
	public static Date getDate(){
		return Calendar.getInstance().getTime();
	}
	
	public static Date getDate(long l){
		return new Date(l);
	}
	
	public static long getTime(){
		return Calendar.getInstance().getTimeInMillis();
	}
	
	public static Date getDateFromNow(long l){
		Date date = getDate();
		return new Date(date.getTime()+l);
	}
	
	public static long getTimeFromNow(long l){
		return getTime()+l;
	}
	
	public static long getIntervalTillTime(long l){
		return Math.max(0, l-getTime());
	}
	
    public static long getIntervalFromTime(long l) {
        return Math.max(0, getTime()-l);
    }

	public static Date getDate(Date date, long lauchtime) {
		return new Date(date.getTime()+lauchtime);
	}
	
	public static String formatTaskTimeString(long remain, long endtime) {
		//return formatTimeString(remain) + " / " + formatDateString(DateUtils.getDate(endtime));
	    return formatTaskTimeString(endtime);
	}
	
	   public static String formatTaskTimeString(long endtime) {
	       long remain = Math.max(0, endtime-DateUtils.getTime());
	        return formatTimeString(remain) + "/" + formatTimeString(DateUtils.getDate(endtime));
	    }
	/**
	 * Format a date to: hh:mm:ss (OLD:yyyy年mm月dd日 hh时mm分ss秒)
	 */
	public static String formatDateString(Date d) {
		StringBuffer result = new StringBuffer("");
		SimpleDateFormat bartDateFormat = new SimpleDateFormat("yyyy-MM-dd-HH-mm-ss");
		String[] datearr = bartDateFormat.format(d).split("-");
		
		result
		.append(datearr[0]).append("年")
		.append(datearr[1]).append("月")
		.append(datearr[2]).append("日")
		.append(" ")
		.append(datearr[3]).append("时")
		.append(datearr[4]).append("分")
		.append(datearr[5]).append("秒")
		;
		return result.toString(); 
	}
	/**
	 * Format a date to: hh:mm:ss
	 */
	public static String formatTimeString(Date d) {
		StringBuffer result = new StringBuffer("");
		SimpleDateFormat bartDateFormat = new SimpleDateFormat("yyyy-MM-dd-HH-mm-ss");
		String[] datearr = bartDateFormat.format(d).split("-");
		
		result
//		.append(datearr[0]).append("年")
//		.append(datearr[1]).append("月")
//		.append(datearr[2]).append("日")
//		.append(" ")
//		.append(datearr[3]).append("时")
//		.append(datearr[4]).append("分")
//		.append(datearr[5]).append("秒")
		.append(datearr[3]).append(":")
		.append(datearr[4]).append(":")
		.append(datearr[5])
		;
		return result.toString(); 
	}
	public static String formatDate(Date d, String format) {
		if(d==null){
			return "";
		}
		if(StringUtils.isEmpty(format)){
			format = "yyyy-MM-dd HH:mm:ss";
		}
		SimpleDateFormat bartDateFormat = new SimpleDateFormat(format);
		return bartDateFormat.format(d);
	}

	public static String format(long l,String format) {
		Date d = getDate(l);
		SimpleDateFormat bartDateFormat = new SimpleDateFormat(format);
		String datearr = bartDateFormat.format(d);

		return datearr;
	}
	
	public static String formatTime(Long time,String format){
		if(time!=null && time>0){
			return format(time,format);
		}
		return "";
	}
	
	public static Date parseDate(String sDate){
	    DateFormat formatter = new SimpleDateFormat("yyyy-MM-dd");
	    Date retDate=null;
	    try {
	      retDate = formatter.parse(sDate);
	    }
	    catch (Exception ex) {
	    }
	    return retDate;
	}

	public static Date parseDate(String sDate, String format){
	    DateFormat formatter = new SimpleDateFormat(format);
	    Date retDate=null;
	    try {
	      retDate = formatter.parse(sDate);
	    }
	    catch (Exception ex) {
	    }
	    return retDate;
	}

	/**
	 * Milliseconds -> hh:mm:ss
	 */
	public static String formatTimeString(long millisecond) {
		millisecond = millisecond < 0 ? -millisecond : millisecond;



		int seconds = (int)(millisecond/1000);

		StringBuffer result = new StringBuffer("");
		int ss = seconds % 60;
		int mm = seconds/60%60;
		int hh = seconds/3600;

		if(hh == 0)
			result.append("00");
		else if(hh < 10)
			result.append("0").append(hh);
		else
			result.append(hh);

		result.append(":");

		if(mm == 0)
			result.append("00");
		else if(mm < 10)
			result.append("0").append(mm);
		else
			result.append(mm);

		result.append(":");

		if(ss == 0)
			result.append("00");
		else if(ss < 10)
			result.append("0").append(ss);
		else
			result.append(ss);

		return result.toString();
	}

	public static int getHour() {
	    Calendar cpcalendar = new GregorianCalendar();
	    cpcalendar.setTime(getDate());
	    return cpcalendar.get(Calendar.HOUR_OF_DAY);
	}

	public static int getHour(Date date) {
	    Calendar cpcalendar = new GregorianCalendar();
        cpcalendar.setTime(date);
        return cpcalendar.get(Calendar.HOUR_OF_DAY);
	}

	   public static int getHour(long date) {
	       return getHour(getDate(date));
	    }


	/**
	 * 年份加减
	 * @param date
	 * @param diff
	 * @return
	 */
	public static Long getYearDiff(long date, int diff) {
		Date d=new Date(date);
	    GregorianCalendar gc = new GregorianCalendar();

	    gc.setTime(d);
	    gc.add(1, diff);
	    gc.set(gc.get(Calendar.YEAR),gc.get(Calendar.MONTH),gc.get(Calendar.DATE));

	    return gc.getTimeInMillis();
	}

	//2012年12月12日　周日　19:20
	public static String getCurDatetime(long date) {
		String[] week = {"周日", "周一", "周二", "周三", "周四", "周五", "周六"};

		Calendar c = Calendar.getInstance();
		c.setTime(new Date(date));
		int w=c.get(Calendar.DAY_OF_WEEK);

		return format(date, "yyyy年MM月dd日 ") + week[w-1] + " " + format(date, "HH:mm");
	}

	//当前时间点距当天0时的毫秒数
	public static long getMillisecondInADay() {
		Calendar cl = Calendar.getInstance();
		return (cl.get(Calendar.HOUR_OF_DAY)*3600 + cl.get(Calendar.MINUTE)*60 + cl.get(Calendar.SECOND))*1000 + cl.get(Calendar.MILLISECOND);
	}

//    public static void checkWeekendWarTime(MessageService messageService) {
//    	if(!LogicalConstants.enableWeekendWar) {
//    		return;
//    	}
//
//		Calendar cl = Calendar.getInstance();
//		int dayofweek = cl.get(Calendar.DAY_OF_WEEK);
////		System.out.println("--------DAY:" + dayofweek + ":HOUR:" + cl.get(Calendar.HOUR_OF_DAY));
//		if(LogicalConstants.OP_LOCALE.startsWith("malay")) {
//			switch(dayofweek) {
//			case Calendar.SATURDAY:
//				isWeekendWarTime = cl.get(Calendar.HOUR_OF_DAY) >= 12;
//
//				if(isWeekendWarTime &&
//						cl.get(Calendar.HOUR_OF_DAY) == 12 && cl.get(Calendar.MINUTE) < 10
//						&& messageService != null) {
//					PlayerSystemMessageHelper.sendMessage(0,
//			                PlayerMessage.SUBTYPE_WORLD_WEEKEND_BEGIN, new String[] {"tmp"},
//			                messageService);
//				}
//				break;
//			case Calendar.SUNDAY:
//				isWeekendWarTime = cl.get(Calendar.HOUR_OF_DAY) < 21;
//
//				if(!isWeekendWarTime &&
//						cl.get(Calendar.HOUR_OF_DAY) == 21 && cl.get(Calendar.MINUTE) < 10
//						&& messageService != null) {
//					PlayerSystemMessageHelper.sendMessage(0,
//			                PlayerMessage.SUBTYPE_WORLD_WEEKEND_OVER, new String[] {"tmp"},
//			                messageService);
//				}
//				break;
//			default:
//				isWeekendWarTime = false;
//			}
//		} else {
//			switch(dayofweek) {
//			case Calendar.FRIDAY:
//				isWeekendWarTime = cl.get(Calendar.HOUR_OF_DAY) >= 21;
//
//				if(isWeekendWarTime &&
//						cl.get(Calendar.HOUR_OF_DAY) == 21 && cl.get(Calendar.MINUTE) < 10
//						&& messageService != null) {
//					PlayerSystemMessageHelper.sendMessage(0,
//			                PlayerMessage.SUBTYPE_WORLD_WEEKEND_BEGIN, new String[] {"tmp"},
//			                messageService);
//				}
//				break;
//			case Calendar.SATURDAY:
//				isWeekendWarTime = true;
//				break;
//			case Calendar.SUNDAY:
//				isWeekendWarTime = cl.get(Calendar.HOUR_OF_DAY) < 21;
//
//				if(!isWeekendWarTime &&
//						cl.get(Calendar.HOUR_OF_DAY) == 21 && cl.get(Calendar.MINUTE) < 10
//						&& messageService != null) {
//					PlayerSystemMessageHelper.sendMessage(0,
//			                PlayerMessage.SUBTYPE_WORLD_WEEKEND_OVER, new String[] {"tmp"},
//			                messageService);
//				}
//				break;
//			default:
//				isWeekendWarTime = false;
//			}
//		}
//
//		if(isWeekendWarTime && cl.get(Calendar.HOUR_OF_DAY) % 5 == 0 && cl.get(Calendar.MINUTE) < 10
//				&& messageService != null) {
//			PlayerSystemMessageHelper.sendMessage(0,
//	    			PlayerMessage.SUBTYPE_WORLD_WEEKEND_GOING, new String[] {"" + MathUtils.getRandom(3)},
//	    			messageService);
//		}
//    }

    public static long getTodayTime() {
        return DateUtils.getTime()-getMillisecondInADay();
    }

    public static String getPlainString(Date dt) {
        SimpleDateFormat bartDateFormat = new SimpleDateFormat("yy-MM-dd-HH-mm-ss");
        StringBuffer result = new StringBuffer("");
        String[] datearr = bartDateFormat.format(dt).split("-");
        result
        .append(datearr[0]).append("-")
        .append(datearr[1]).append("-")
        .append(datearr[2]).append("-")
        .append(" <a name=\"ta\">")
        .append(datearr[3]).append(":")
        .append(datearr[4]).append(":")
        .append(datearr[5]).append("</a>");
        return result.toString();
    }

    public static String getPlainString2(Date dt) {
        SimpleDateFormat bartDateFormat = new SimpleDateFormat("yy-MM-dd-HH-mm-ss");
        StringBuffer result = new StringBuffer("");
        String[] datearr = bartDateFormat.format(dt).split("-");
        result
        .append(datearr[0]).append("-")
        .append(datearr[1]).append("-")
        .append(datearr[2]).append(" ")
        .append(datearr[3]).append(":")
        .append(datearr[4]).append(":")
        .append(datearr[5]);
        return result.toString();
    }

    public static String getPlainString3(Date dt) {
        SimpleDateFormat bartDateFormat = new SimpleDateFormat("yy-MM-dd");
        StringBuffer result = new StringBuffer("");
        String[] datearr = bartDateFormat.format(dt).split("-");
        result
        .append(datearr[0]).append("-")
        .append(datearr[1]).append("-")
        .append(datearr[2]).append(" ");
        return result.toString();
    }

    public  static String  getPlainString4(Date dt) {
    	 SimpleDateFormat bartDateFormat = new SimpleDateFormat(DateUtils.DATE_TIME_PARRTEN);
    	 String result = bartDateFormat.format(dt);
    	 return result;
    }

    /**
     * 将毫秒转成yyyy-MM-dd HH:mm:ss的时间格式
     * @param date     毫秒
     * @return
     */
    public static String parseLongtoTime(long date) {
    	return new SimpleDateFormat(DateUtils.DATE_TIME_PARRTEN).format(new Date(date));
 	}

     /**
      * 将毫秒转成yyyyMMdd的时间格式
      * @param date     毫秒
      * @return
      */
    public static String parseLongtoTime2(long date) {
  		return new SimpleDateFormat("yyyyMMdd").format(new Date(date));
  	}
    /**
     * 将时间字符串转换为long
     * @param date
     * @return
     * @throws ParseException
     */
    public static Long parseStringToLong(String date) throws ParseException{
    	if(StringUtils.isEmpty(date)){
    		return null;
    	}
    	SimpleDateFormat format = new SimpleDateFormat(DateUtils.DATE_TIME_PARRTEN);
		Date e = format.parse(date);
		return e.getTime();
    }

    /**
     * 将时间字符串转换为long
     * @param date	要转换的时间
     * @param fmt	要转换的时间格式,如:yyyy-MM-dd或者yyyy-MM-dd HH:mm:ss
     * @return		long型的时间
     * @throws ParseException
     */
    public static Long parseStringToLong(String date,String fmt){
    	Date e = null;
    	if(StringUtils.isEmpty(date)){
    		return null;
    	}
    	try{
	    	SimpleDateFormat format = new SimpleDateFormat(fmt);
			e = format.parse(date);
    	}catch(Exception ex){
    		ex.printStackTrace();
    	}
		return e !=null ? e.getTime() : null;
    }

	/**
	 * 获取一个日期增加days天后的日期
	 * DateUtils.addTime("2011-09-26","yyyy-MM-dd",10)
	 * 2011-10-06
	 * @author 肖平松
	 * @version Sep 27, 2011
	 * @param datetime		时间
	 * @param parrten		时间格式
	 * @param days			增加的天数
	 * @return				新的时间
	 */
	public static String addTime(String datetime, String parrten, long days) {
		SimpleDateFormat formatter = new SimpleDateFormat(parrten);
		ParsePosition pos = new ParsePosition(0);
		Date dt1 = formatter.parse(datetime, pos);
		long l = dt1.getTime() / 1000 + days * 24 * 60 * 60;
		dt1.setTime(l * 1000);
		String mydate = formatter.format(dt1);
		return mydate;
	}

	/**
	 * 获取一个日期之前n天的日期
	 * @param datetime
	 * @param parrten
	 * @param days
	 * @return
	 */
	public static String subtractTime(String datetime, String parrten, long days) {
		SimpleDateFormat formatter = new SimpleDateFormat(parrten);
		ParsePosition pos = new ParsePosition(0);
		Date dt1 = formatter.parse(datetime, pos);
		long l = dt1.getTime() / 1000 - days * 24 * 60 * 60;
		dt1.setTime(l * 1000);
		String mydate = formatter.format(dt1);
		return mydate;
	}

	/**
	 * 时间d增加m分钟
	 * DateUtils.addTime(new Date(),10)	//当前时间增加10分钟
	 * Tue Sep 27 15:58:19 GMT 2011
	 * @author 肖平松
	 * @version Sep 27, 2011
	 * @param d		要增加的时间
	 * @param m		要增加的分钟
	 * @return		新的时间
	 */
	public static Date addTime(Date d, int m) {
		Calendar cal = Calendar.getInstance();
		cal.setTime(d);
		cal.add(Calendar.MINUTE, m);
		return cal.getTime();
	}

	/**
	 * 得到昨天的日期
	 * @return	昨天的日期字符串
	 * 如果今天是2012-09-28，则返回2012-09-27
	 */
	public static String getYesterday() {
		String timestr;
		Calendar cc = Calendar.getInstance();
		cc.roll(Calendar.DAY_OF_YEAR, -1);
		SimpleDateFormat sdf = new SimpleDateFormat(DateUtils.DATE_PARRTEN);
		if ((cc.get(Calendar.MONTH) + 1) == 1
				&& cc.get(Calendar.DAY_OF_MONTH) == 1) {
			cc.roll(Calendar.YEAR, 1);
		}
		timestr = sdf.format(cc.getTime());
		return timestr;
	}

	/**
	 * 获取本周一的日期
	 * @return	本周一的日期
	 * 如果今天是2012-09-28(星期五)，则返回2012-09-24
	 */
	public static String getMondayOfWeek(){
        int mondayPlus = getMondayPlus();
        GregorianCalendar currentDate = new GregorianCalendar();
        currentDate.add(Calendar.DATE, mondayPlus);
        Date monday = currentDate.getTime();

        DateFormat df = DateFormat.getDateInstance();
        String preMonday = df.format(monday);
        return preMonday;
   }

	/**
	 * 获取本周日的日期
	 * @return	本周日的日期
	 * 如果今天是2012-09-28(星期五)，则返回2012-09-30
	 */
	public static String getSundayOfWeek() {
        int mondayPlus = getMondayPlus();
        GregorianCalendar currentDate = new GregorianCalendar();
        currentDate.add(Calendar.DATE, mondayPlus+6);
        Date monday = currentDate.getTime();

        DateFormat df = DateFormat.getDateInstance();
        String preMonday = df.format(monday);
        return preMonday;
    }

	/**
	 * 获取上周一的日期
	 * @return 上周一的日期
	 * 如果今天是2012-09-28(星期五)，则返回2012-9-17
	 */
	public static String getMondayOfPreviousWeek() {
		int weeks = -1;
        int mondayPlus = getMondayPlus();
        GregorianCalendar currentDate = new GregorianCalendar();
        currentDate.add(Calendar.DATE, mondayPlus + 7 * weeks);
        Date monday = currentDate.getTime();
        DateFormat df = DateFormat.getDateInstance();
        String preMonday = df.format(monday);
        return preMonday;
    }

	/**
	 * 获取上周日的日期
	 * @return 上周日的日期
	 * 如果今天是2012-09-28(星期五)，则返回2012-9-23
	 */
	public static String getSundayOfPreviousWeek() {
        int weeks = -1;
        int mondayPlus = getMondayPlus();
        GregorianCalendar currentDate = new GregorianCalendar();
        currentDate.add(Calendar.DATE, mondayPlus+weeks);
        Date monday = currentDate.getTime();
        DateFormat df = DateFormat.getDateInstance();
        String preMonday = df.format(monday);
        return preMonday;
    }

	/**
	 * 获取本月第一天的日期
	 * @return 本月第一天的日期
	 * 如果今天是2012-09-28(星期五)，则返回2012-09-01
	 */
	public static String getFirstDayOfMonth(){
       String str = "";
       SimpleDateFormat sdf=new SimpleDateFormat("yyyy-MM-dd");
       Calendar lastDate = Calendar.getInstance();
       lastDate.set(Calendar.DATE,1);//设为当前月的1号
       str=sdf.format(lastDate.getTime());
       return str;
    }

	/**
	 * 获取本月第一天的日期
	 * @return 本月第一天的日期
	 * 如果今天是2012-09-28(星期五)，则返回2012-09-30
	 */
	public static String getLastDayOfMonth(){
       String str = "";
       SimpleDateFormat sdf=new SimpleDateFormat("yyyy-MM-dd");
       Calendar lastDate = Calendar.getInstance();
       lastDate.set(Calendar.DATE,1);//设为当前月的1号
       lastDate.add(Calendar.MONTH,1);//加一个月，变为下月的1号
       lastDate.add(Calendar.DATE,-1);//减去一天，变为当月最后一天
       str=sdf.format(lastDate.getTime());
       return str;
    }

	/**
	 * 获取上月第一天的日期
	 * @return 上月第一天的日期
	 * 如果今天是2012-09-28(星期五)，则返回2012-08-01
	 */
	public static String getFirstDayOfPreviousMonth(){
       String str = "";
       SimpleDateFormat sdf=new SimpleDateFormat("yyyy-MM-dd");
       Calendar lastDate = Calendar.getInstance();
       lastDate.set(Calendar.DATE,1);//设为当前月的1号
       lastDate.add(Calendar.MONTH,-1);//减一个月，变为下月的1号
       str=sdf.format(lastDate.getTime());
       return str;
    }

	/**
	 * 获取上月最后一天的日期
	 * @return 上月最后一天的日期
	 * 如果今天是2012-09-28(星期五)，则返回2012-08-31
	 */
	public static String getLastDayOfPreviousMonth(){
        String str = "";
        SimpleDateFormat sdf=new SimpleDateFormat("yyyy-MM-dd");
        Calendar lastDate = Calendar.getInstance();
        lastDate.add(Calendar.MONTH,-1);//减一个月
        lastDate.set(Calendar.DATE, 1);//把日期设置为当月第一天
        lastDate.roll(Calendar.DATE, -1);//日期回滚一天，也就是本月最后一天
        str=sdf.format(lastDate.getTime());
        return str;
    }

	/**
	 * 日期格式转换
	 * DateUtils.getDate(new Date(),DateUtils.DATE_PARRTEN)
	 * 2012-09-28
	 * @param date		日期
	 * @param parrten	输出的时间格式
	 * @return			日期字符串
	 */
	public static String getDate(Date date, String parrten) {
		if (parrten == null || parrten.equals("")) {
			parrten = DateUtils.DATE_PARRTEN;
		}
		return DateUtils.getTime(date, parrten);
	}

	/**
	 * 获得当天日期
	 * DateUtils.getDate(null)
	 * 2012-09-28
	 * @param parrten	输出的日期格式
	 * @return			返回日期
	 */
	public static String getDate(String parrten) {
		if (parrten == null || parrten.equals("")) {
			parrten = DateUtils.DATE_PARRTEN;
		}
		return DateUtils.getTime(parrten);
	}

	/**
	 * 获得当天时间
	 * DateUtils.getTime(null)
	 * 2012-09-28 13:52:30
	 * @param parrten	输出的时间格式
	 * @return 			返回时间
	 */
	public static String getTime(String parrten) {
		String timestr;
		if (parrten == null || parrten.equals("")) {
			parrten = DateUtils.DATE_TIME_PARRTEN;
		}
		SimpleDateFormat sdf = new SimpleDateFormat(parrten);
		Date cday = new Date();
		timestr = sdf.format(cday);
		return timestr;
	}

	/**
	 * 时间格式转换
	 * DateUtils.getTime(new Date(),DateUtils.DATE_TIME_PARRTEN)
	 * 2012-09-28 13:51:50
	 * @param cday		时间
	 * @param parrten	输出的时间格式
	 * @return			时间字符串
	 */
	public static String getTime(Date cday, String parrten) {
		if (cday == null)
			return "";
		String timestr;
		if (parrten == null || parrten.equals("")) {
			parrten = DateUtils.DATE_TIME_PARRTEN;
		}
		SimpleDateFormat sdf = new SimpleDateFormat(parrten);
		timestr = sdf.format(cday);
		return timestr;
	}

	// 获得当前日期与本周日相差的天数
    private static int getMondayPlus() {  
        Calendar cd = Calendar.getInstance();  
        // 获得今天是一周的第几天，星期日是第一天，星期二是第二天......  
        int dayOfWeek = cd.get(Calendar.DAY_OF_WEEK)-1;//因为按中国礼拜一作为第一天所以这里减1  
        if (dayOfWeek == 1) {  
            return 0;  
        } else {  
            return 1 - dayOfWeek;  
        }  
    }  

    //根据开始时间、结束时间得到两个时间段内所有的日期
    public static  List<Date> getDateArrays(Date start, Date end) {  
    	  List<Date> ret = new ArrayList<Date>();  
    	  Calendar calendar = Calendar.getInstance();  
    	  calendar.setTime(start);  
    	  Date tmpDate = calendar.getTime();  
    	  long endTime = end.getTime();  
    	  while (tmpDate.before(end) || tmpDate.getTime() == endTime) {  
    	    ret.add(calendar.getTime());  
    	    calendar.add(Calendar.DAY_OF_MONTH, 1);  
    	    tmpDate = calendar.getTime();  
    	  }  
    	  return ret;
    	}  

    //比较日期是否小于当前日期
    //参数 yyyy-mm-dd
    public static boolean compareSmallerThanNowDate(String targetDateStr){
    	String[] targetDate = targetDateStr.split("-");
    	int targetYear = Integer.parseInt(targetDate[0]);
    	int targetMonth = Integer.parseInt(targetDate[1]);
    	int targetDay = Integer.parseInt(targetDate[2]);
    	Calendar cal = Calendar.getInstance();
    	if(cal.get(Calendar.YEAR)>targetYear){
    		return true;
    	}else{
    		if(cal.get(Calendar.YEAR)==targetYear){
    			if(cal.get(Calendar.MONTH)+1>targetMonth){
    				return true;
    			}else{
    				if(cal.get(Calendar.MONTH)+1==targetMonth){
    					if(cal.get(Calendar.DAY_OF_MONTH)>targetDay){
    						return true;
    					}
    				}
    			}
    		}
    	}
    	return false;
    }
    
    public static Timestamp getCurrentTimestamp() {
    	return new Timestamp(new Date().getTime());
    }
    /*
    public static void main(String[] args) {
    	System.err.println(compareSmallerThanNowDate("2014-04-18"));
	}*/
    
    public static void parseTime2() {
        try {
            String time = "20131227085009";
            SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyyMMddHHmmss");
            Date date = simpleDateFormat.parse(time);
            simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            // SimpleDateFormat的format(Date date)方法将Date转换为String
            String formattedTime = simpleDateFormat.format(date);
            System.out.println("---->将" + time + "解析为:" + formattedTime);
        } catch (Exception e) {
     
        }
    }

	/**
	 * 
	 * 当前日期的基础上加上num天
	 */
	public static Date addDay(Date date,int num){
		if (date == null) {
			return null;
		}
		Calendar cal = Calendar.getInstance();
		cal.setTime(date);
		cal.add(Calendar.DAY_OF_MONTH, num);
		return cal.getTime();
	}
    public static void main(String[] args) {
    	parseTime2();
	}
}

