package com.ipsa.learn.util;

import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.HttpStatus;
import org.apache.commons.httpclient.UsernamePasswordCredentials;
import org.apache.commons.httpclient.auth.AuthScope;
import org.apache.commons.httpclient.methods.PostMethod;
import org.apache.commons.httpclient.methods.StringRequestEntity;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

public class HttpRequestHelper {

	 /**
	  * 设置代理
	  */
	private static void setProxy(HttpClient client,String httpHost,int httpPort,String httpUser,String httpPassword) {
	  // 设置代理
	  client.getHostConfiguration().setProxy(httpHost, httpPort);
	  client.getState().setProxyCredentials(AuthScope.ANY,
	    new UsernamePasswordCredentials(httpUser, httpPassword));
	 }
	public static String requestByPost(String urlString, String charset, String data){
//		return requestByPost(urlString, charset, data, true, "10.199.75.12", 8080, "v_liuqingsong", "lqs123321");
		return requestByPost(urlString, charset, data, false, "", 8080, "", "");
	}
	public static String requestByPostProxy(String urlString, String charset, String data,String httpHost,int httpPort,String httpUser,String httpPassword){
		return requestByPost(urlString, charset, data, true, httpHost, httpPort, httpUser, httpPassword);
	}
	private static String requestByPost(String urlString, String charset, String data,boolean isProxy,String httpHost,int httpPort,String httpUser,String httpPassword) {
		InputStream is = null;
		PostMethod postMethod = null;
		StringBuffer html = new StringBuffer();
		try {
			HttpClient httpclient = new HttpClient();
			httpclient.getParams().setParameter("http.protocol.content-charset", charset);
			httpclient.getParams().setBooleanParameter("http.protocol.expect-continue", false);   
			postMethod = new PostMethod(urlString); 
			postMethod.addRequestHeader("Connection", "Keep-Alive");
			postMethod.addRequestHeader("ContentType", "application/xml; charset="+charset);
			postMethod.setRequestEntity(new StringRequestEntity(data, "application/xml", charset));
			if(isProxy){
				setProxy(httpclient, httpHost, httpPort, httpUser, httpPassword);
			}
			int result = httpclient.executeMethod(postMethod);
			if (result == HttpStatus.SC_OK) {
				is = postMethod.getResponseBodyAsStream();
				InputStreamReader isReader = new InputStreamReader(is, charset);
				BufferedReader bf = new BufferedReader(isReader);
                String temp;
                while ((temp = bf.readLine()) != null) {
                	html.append(temp);
                }
                isReader.close();
                isReader = null;
                bf.close();
                bf = null;
			} else {
				System.out.println("result of function getHtml(" + urlString + ", " + charset + ") is " + result);
			}
		} catch (Exception e) {
			System.out.println("getHtml(" + urlString + ", " + charset + ") occur exception: " + e);
			return null;
		} finally {
			if (is != null) {
				try {
					is.close();
					is = null;
				} catch (IOException e) {
					System.out.println("finally-->IOException-->" + e);
				}
			}
			if (postMethod != null) {
				postMethod.releaseConnection();
				postMethod = null;
			}
		}
		
		return html.toString();
	}
}
