package com.ipsa.learn.util;

import com.ipsa.learn.util.connect.IConnect;
import com.ipsa.learn.util.connect.Message;
import com.ipsa.learn.util.connect.Result;
import com.ipsa.learn.util.connect.impl.Connect;
import org.apache.commons.lang3.StringUtils;
import org.dom4j.Document;
import org.dom4j.DocumentHelper;
import org.dom4j.Element;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;


/**
 * 短信发送 service
 * @author qsliu
 *
 */
@Service
public class MsgManager {
	
	private Logger logger = LoggerFactory.getLogger(MsgManager.class);
	
	
	/**
	 * 发送短信
	 * @param mobile
	 * @param content
	 * @return
	 * @throws Exception 
	 */
	public Boolean sendMsg(String content, String... mobile) throws Exception{
		Boolean returnFlag = false;
		String returnCode = "";
//		SmsLog sl = new SmsLog();
/*		Result r = interactiveConnect(Constants.SYSTEM_SERVLET_COMMAND_CONNECT,"msg_url1");
		if(Constants.RETURN_STATUS_FAIL.equals(r.getStatus())){
			r = interactiveConnect(Constants.SYSTEM_SERVLET_COMMAND_CONNECT,"msg_url2");
			if(Constants.RETURN_STATUS_SUCCESS.equals(r.getStatus())){
				r = interactiveSengMsg(Constants.SYSTEM_SERVLET_COMMAND_SENDMSG,"msg_url2", content, mobile);
				returnCode = analysisXml((String) r.getData());
			}
		}else if(Constants.RETURN_STATUS_SUCCESS.equals(r.getStatus())){
			r = interactiveSengMsg(Constants.SYSTEM_SERVLET_COMMAND_SENDMSG,"msg_url1", content, mobile);
			returnCode = analysisXml((String) r.getData());
		}
		if(Constants.RETURN_STATUS_SUCCESS.equals(r.getStatus())){
			returnFlag = true;
		}else if(Constants.RETURN_STATUS_FAIL.equals(r.getStatus())){
		}else{
		}*/
		//保存短信日志
		return returnFlag;
	}
	
	/**
	 * 调用测试连接的任务
	 * @param command
	 * @param url
	 * @return
	 * @throws Exception
	 */
	private Result interactiveConnect(String command, String url) throws Exception{
		Message m = new Message(command,url);
		IConnect c = new Connect();
		return c.interactive(m);
	}
	
	/**
	 * 调用发送短信的任务
	 * @param command
	 * @param url
	 * @param mobile
	 * @param content
	 * @return
	 * @throws Exception
	 */
	private Result interactiveSengMsg(String command, String url, String content, String... mobile) throws Exception{
		logger.debug("-----------------发送短信手机:"+mobile.toString()+"-----------------发送短信内容:"+content);
		Message m = new Message(command,url);
		m.setAttribute("mobile", mobile);
		m.setAttribute("content", content);
		m.setAttribute("flag", "emay");
		IConnect c = new Connect();
		return c.interactive(m);
	}
	
	/**
	 * 解析返回的xml
	 * @param xml
	 * @return
	 */
	private String analysisXml(String xml){
		String returnCode = "";
		String statusCode = "";
		String errorCode = "";
		//如果使用的是emay的短信接口，则可以直接返回
		if(Constants.RETURN_STATUS_SUCCESS.equalsIgnoreCase(xml)){
			return Constants.RETURN_STATUS_SUCCESS;
		}else if(Constants.RETURN_STATUS_FAIL.equalsIgnoreCase(xml)){
			return Constants.RETURN_STATUS_FAIL;
		}else if(xml.matches("[0-9]+")){
			return xml;
		}
		try {
			Document document = DocumentHelper.parseText(xml);
			// 输出信息
			Element baseInfo = document.getRootElement();
			statusCode = baseInfo.element("Status").getText();
			if(StringUtils.isNotBlank(statusCode)){
				if(Constants.RETURN_STATUS_SUCCESS.equals(statusCode)){
					returnCode = statusCode;
				}else{
					errorCode = baseInfo.element("ErrCode").getText();
					returnCode = errorCode;
				}
			}
		} catch (Exception e) {
			logger.error("----------解析短信平台返回XML时出错："+e);
		}
		return returnCode;
	}
	
	/**
	 * 解析返回的xml
	 * @param xml
	 * @return
	 */
	private String analysisValue(String returnValue){
		String returnCode = "";
		try {
			if("ok".equalsIgnoreCase(returnValue)){
				returnCode = Constants.RETURN_STATUS_SUCCESS;
			}else{
				returnCode = Constants.RETURN_STATUS_FAIL;
			}
		} catch (Exception e) {
			logger.error("----------解析短信平台返回数据出错："+e);
		}
		return returnCode;
	}
	/**
	 * 发送系统短信给管理员
	 * @param content
	 * @param mobileType 短信类型  例如 warn
	 * @return
	 * @throws Exception
	 */
	public Boolean sendMsg(String content) throws Exception{
//		String[] mobile = ResourceBundleUtil.getString("admin_mobile").split(",");
		/*MsgInfo msgInfo = msgService.queryMsgInfo();
		String mobile = "";
		if(msgInfo != null){
			mobile = msgInfo.getReceivePhone();
		}
		if(StringUtils.isNotBlank(mobile)){
			return sendMsg(content, mobile);
		}else{
			logger.error("手机号未找到，请配置手机号，短信内容：" + content);
			return false;
		}*/
		logger.error("短信内容：" + content);
		return true;
	}
	
	public String buildCallPayGatewayErrorContent(String gatewayName, String orderNo) {
		StringBuffer sb = new StringBuffer();
		sb.append(String.format("订单号：%s\r\n", orderNo));
		sb.append(String.format("调用%s网关失败，请检查服务器网络是否畅通。", gatewayName));
		return sb.toString();
	}
	
	public String buildGatewayConfErrorContent(String paymentMethod, String channelId) {
		StringBuffer sb = new StringBuffer();
		sb.append(String.format("渠道：%s，\r\n", channelId));
		sb.append(String.format("支付方式：%s，\r\n不存在对应的网关信息，请配置对应的收款账号信息。", paymentMethod));
		return sb.toString();
	}

}
