package com.ipsa.learn.util;

import org.springframework.util.CollectionUtils;

import java.util.ArrayList;
import java.util.List;

public class ParameterStatus {

	//订单状态
	public static final String PAY_DUE = "TRADE_NO_PAID"; //未支付
	public static final String PAY_MADE = "TRADE_PAID"; //已支付
	public static final String PAY_FAIL = "TRADE_FAIL"; //支付失败
	public static final String PAY_REFUND_SUCCESS = "REFUND_SUCCESS"; //退款成功
	public static final String PAY_REFUND_FAIL = "REFUND_FAIL"; //退款失败
	
	public static final String PAY_REFUND_APPLY = "REFUND_APPLY"; //退款申请
	
	//支付方式
//	public static final String PAY_METHOD_ALIPAY = "ALIPAY"; //支付宝
//	public static final String PAY_METHOD_UNIONPAY = "UNIONPAY";//银联
//	public static final String PAY_METHOD_TENPAY = "TENPAY";//财付通
//	public static final String PAY_METHOD_WECHAT = "WECHAT";//微信
	public static final String PAY_METHOD_ALIPAY = "10221080"; //支付宝
	public static final String PAY_METHOD_UNIONPAY = "10221130";//银联
	public static final String PAY_METHOD_TENPAY = "10221090";//财付通
	public static final String PAY_METHOD_WECHAT = "10221100";//微信
	public static final String PAY_METHOD_WECHAT_MICO = "10221105";//微信扫码
	public static final String PAY_METHOD_FAST_MONEY = "10221110";//快钱
	
	//财付通退款状态
	public static final String TENPAY_REFUND_1 = "1";//待审批
	public static final String TENPAY_REFUND_2 = "2";//审批流程中
	public static final String TENPAY_REFUND_3 = "3";//审批失败
	public static final String TENPAY_REFUND_4 = "4";//退款成功
	public static final String TENPAY_REFUND_10 = "10";//退款成功
	
	//交易状态
	public static final String TRADE_WAIT_BUYER_PAY = "WAIT_BUYER_PAY";
	
	//交易成功状态集合
	private static List<String> statuslist;
	
	public static boolean TradeSuccess(String status){
		return statuslist.contains(status);
	}
	
	static{
		if(CollectionUtils.isEmpty(statuslist)){
			statuslist = new ArrayList<String>();
			statuslist.add("TRADE_FINISHED");
			statuslist.add("TRADE_SUCCESS");
			statuslist.add("success");
			statuslist.add("SUCCESS");
			statuslist.add("0");//财付通成功状态
			statuslist.add("20");//网银在线成功状态
			statuslist.add("1001");//银联成功
			statuslist.add("00");//银联成功_new
			statuslist.add("A6");//银联成功_new
		}
	}
	//快钱交易结果
	public static final String PAY_RESULT_FAST_MONEY_SUCCESS = "10";//支付成功

	//快钱人民币退款交易状态
	public static final String REFUND_RESULT_FAST_MONEY_ONGOING = "0";//进行中
	public static final String REFUND_RESULT_FAST_MONEY_SUCCESS = "1";//成功
	public static final String REFUND_RESULT_FAST_MONEY_FAIL = "2";//失败
	
	public static final String RETURN_REFUND_SUCCESS = "true"; //退款返回的成功
	public static final String RETURN_REFUND_FAIL = "false"; //退款返回的失败
	
	//银联交易结果
	public static final String PAY_UNION_SUCCESS = "00";//支付成功
	
//  2019.05.31
	public static final String PAY_METHOD_YIWANGTONGPAY = "10221250";//一网通WAP  
	public static final String PAY_METHOD_YIWANGTONGPAYAPP = "10221260";//一网通APP   
	
	
	//一网通支付成功结果
	public static final String PAY_YWT_SUCCESS = "TRADE_SUCCESS";//支付成功
	

	//一网通交易成功订单状态
	public static final String CMB_ORDERSTATUS_0 = "0";//已结帐
	public static final String CMB_ORDERSTATUS_1 = "1";//已撤销
	public static final String CMB_ORDERSTATUS_2 = "2";//部分结帐
	public static final String CMB_ORDERSTATUS_3 = "4";//未结帐
	public static final String CMB_ORDERSTATUS_6 = "6";//未知状态
	public static final String CMB_ORDERSTATUS_4 = "7";//冻结交易-冻结金额已经全部结账
	public static final String CMB_ORDERSTATUS_5 = "8";//冻结交易，冻结金额只结帐了一部分

	
}
