package com.ipsa.learn.util;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.MissingResourceException;
import java.util.ResourceBundle;


public class WechatConfig {
	private static Logger _log = LoggerFactory.getLogger(WechatConfig.class);
	//微信网关
	public final static String WECHAT_GATEWAY = "weixin://wxpay/bizpayurl";
	public final static String WECHAT_UNIFIEDORDER = "https://api.mch.weixin.qq.com/pay/unifiedorder";
	public final static String WECHAT_ORDERQUERY = "https://api.mch.weixin.qq.com/pay/orderquery";
	public final static String WECHAT_REFUND = "https://api.mch.weixin.qq.com/secapi/pay/refund";
	public final static String WECHAT_REFUNDQUERY = "https://api.mch.weixin.qq.com/pay/refundquery";
	public final static String BANK_TYPE = "WX";
	public final static String FEE_TYPE = "1";
	public final static String _INPUT_CHARSET = "UTF-8";
	private static final String PROPERTY_FILE = "wechat";
	
	public static String getString(String property) {
		ResourceBundle bundle = ResourceBundle.getBundle(PROPERTY_FILE);
		try {
			Object o = bundle.getObject(property);
			if (o == null)
				return null;
			else
				return (String) o;
		} catch (MissingResourceException e) {
			_log.error(e.getMessage());
		}
		return null;
	}
}
