package com.ipsa.learn.util.connect.impl;

import com.ipsa.learn.util.Constants;
import com.ipsa.learn.util.connect.IConnect;
import com.ipsa.learn.util.connect.Message;
import com.ipsa.learn.util.connect.Result;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.HttpURLConnection;
import java.net.URL;

public class Connect implements IConnect {
	
	private Logger logger = LoggerFactory.getLogger(Connect.class);
	
	@Override
	public Result interactive(Message message) throws IOException {
		Result result = new Result();
		HttpURLConnection connection = null;
		ObjectInputStream in = null;
		URL url = new URL(message.getLink());
		try {
			message.setAttribute(Constants.SYSTEM_SERVLET_COMMAND, message.getCommand());
			connection = (HttpURLConnection) url.openConnection();
			connection.setRequestMethod("POST");
			connection.setDoInput(true);
			connection.setDoOutput(true);
			connection.setUseCaches(false);
			ObjectOutputStream out = new ObjectOutputStream(connection.getOutputStream());
			out.writeObject(message.getParam());
			out.flush();
			out.close();

			InputStream isObj = connection.getInputStream();
			in = new ObjectInputStream(isObj);
			result = (Result) in.readObject();
		} catch (Exception e) {
			logger.error("连接失败："+e);
		} finally {
			if (in != null) {
				in.close();
				in = null;
			}
			if (connection != null) {
				connection.disconnect();
				connection = null;
			}
		}
		return result;
	}
	
}
