package com.ipsa.learn.util.dingtalkUtil;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.dingtalk.api.DefaultDingTalkClient;
import com.dingtalk.api.DingTalkClient;
import com.dingtalk.api.request.*;
import com.dingtalk.api.response.*;
import com.ipsa.learn.entity.UserVo;
import com.ipsa.learn.util.SecurityUtil;
import com.taobao.api.ApiException;
import lombok.extern.slf4j.Slf4j;

import javax.servlet.http.HttpServletRequest;
import java.net.URLDecoder;
import java.util.*;
@Slf4j
public class CssDingUtil {

    /**
     * AgentId：861525391
     AppKey：dingpgi4doanplmwivpz
     AppSecret：Tcsq_7sPr83hlmDUvrqvu0Ca3MWtn_GbifRYz6PEMIAjuONfc1dkv2KG--uh1HRh
     */

    private static final String APP_KEY = "dingxnufegzyw0wyfukj";
    private static final String APP_SECRET = "Qk1uwc9zpJtPFQdKmjTNRApTw4I6to8jEviCYSu9vTNAyV8kPHgNzLnGdJyjUy5y";
    private static final Long  APP_AGENTID = 864169513L;
    private static final Long CSS_DEPT_PID = 118063635L;
    /**
     * 根据用户Id查询用户角色
     * @param userId
     * @return
     */
    public static OapiEduRolesGetResponse getClassParentsList(String userId){
        try {
            String access_token = getAccessToken();
            DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/edu/roles/get");
            OapiEduRolesGetRequest req = new OapiEduRolesGetRequest();
            req.setUserid(userId);
            OapiEduRolesGetResponse rsp = client.execute(req, access_token);
            return rsp;
        } catch (ApiException e) {
            e.printStackTrace();
        }
        return null;
    }

    /**
     * 根据班级id 查询家长列表
     * @param classId
     * @return
     */
    public static OapiEduGuardianListResponse getClassParentsList(Long classId,Long pageNo,Long pageSize){
        try {
            String access_token = getAccessToken();
            DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/edu/guardian/list");
            OapiEduGuardianListRequest req = new OapiEduGuardianListRequest();
            req.setClassId(classId);
            req.setPageNo(pageNo);
            req.setPageSize(pageSize);
            OapiEduGuardianListResponse rsp = client.execute(req, access_token);
            System.out.println(rsp.getBody());
            return rsp;
        } catch (ApiException e) {
            e.printStackTrace();
        }
        return null;
    }

    /**
     * 根据班级id 家长Id查找家长信息
     * @param classId
     * @param guarDianUserId
     * @return
     */
    public static OapiEduGuardianGetResponse getClassParents(Long classId,String guarDianUserId){
        try {
            String access_token = getAccessToken();
            DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/edu/guardian/get");
            OapiEduGuardianGetRequest req = new OapiEduGuardianGetRequest();
            req.setClassId(classId);
            req.setGuardianUserid(guarDianUserId);
            OapiEduGuardianGetResponse rsp = client.execute(req, access_token);
            System.out.println(rsp.getBody());
            return rsp;
        } catch (ApiException e) {
            e.printStackTrace();
        }
        return null;
    }

    /**
     * 根据班级id 查找老师列表
     * @param classId
     * @return
     */
    public static OapiEduTeacherListResponse getClassTeacherList(Long classId){
        try {
            String access_token = getAccessToken();
            DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/edu/teacher/list");
            OapiEduTeacherListRequest req = new OapiEduTeacherListRequest();
            req.setClassId(classId);
            OapiEduTeacherListResponse rsp = client.execute(req, access_token);
            System.out.println(rsp.getBody());
            return rsp;
        } catch (ApiException e) {
            e.printStackTrace();
        }
        return null;
    }

    /**
     * 根据班级id 用户Id查找老师信息
     * @param classId
     * @param teacherUserId
     * @return
     */
    public static OapiEduTeacherGetResponse getClassTeacher(Long classId,String teacherUserId){
        try {
            String access_token = getAccessToken();
            DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/edu/teacher/get");
            OapiEduTeacherGetRequest req = new OapiEduTeacherGetRequest();
            req.setClassId(classId);
            req.setTeacherUserid(teacherUserId);
            OapiEduTeacherGetResponse rsp = client.execute(req, access_token);
            System.out.println(rsp.getBody());
            return rsp;
        } catch (ApiException e) {
            e.printStackTrace();
        }
        return null;
    }
    /**
     * 根据班级id查询学生列表
     * @param classId
     * @param pageNo
     * @param pageSize
     * @return
     */
    public static OapiEduStudentListResponse getStudentList(Long classId,Long pageNo,Long pageSize){
        try {
            String access_token = getAccessToken();
            DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/edu/student/list");
            OapiEduStudentListRequest req = new OapiEduStudentListRequest();
            req.setClassId(classId);
            req.setPageNo(pageNo);
            req.setPageSize(pageSize);
            OapiEduStudentListResponse rsp = client.execute(req, access_token);
            System.out.println(rsp.getBody());
            return rsp;
        } catch (ApiException e) {
            e.printStackTrace();
        }
        return null;
    }

    /**
     * 根据班级id,学生id，查找学生信息
     * @param classId
     * @param studentUserId
     * @return
     */
    public static OapiEduStudentGetResponse getStudentName(Long classId,String studentUserId){
        try {
            String access_token = getAccessToken();
            DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/edu/student/get");
            OapiEduStudentGetRequest req = new OapiEduStudentGetRequest();
            req.setClassId(classId);
            req.setStudentUserid(studentUserId);
            OapiEduStudentGetResponse rsp = client.execute(req, access_token);
            System.out.println(rsp.getBody());
            return rsp;
        } catch (ApiException e) {
            e.printStackTrace();
        }
        return null;
    }

    /**
     * 根据班级Id查询班级信息
     * @param classId
     * @return
     */
    public static OapiEduClassGetResponse getEduInFormAtion(Long classId){
        try {
            String access_token = getAccessToken();
            DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/edu/class/get");
            OapiEduClassGetRequest req = new OapiEduClassGetRequest();
            req.setClassId(classId);
            OapiEduClassGetResponse rsp = client.execute(req, access_token);
            System.out.println(rsp.getBody());
            return rsp;
        } catch (ApiException e) {
            e.printStackTrace();
        }
        return null;
    }

    /**
     * 根据年级Id查询班级列表
     * @param gradeId
     * @param pageNo
     * @param pageSize
     * @return
     */
    public static OapiEduClassListResponse getEduPeriodClass(Long gradeId,Long pageNo,Long pageSize){
        try {
            String access_token = getAccessToken();
            DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/edu/class/list");
            OapiEduClassListRequest req = new OapiEduClassListRequest();
            req.setGradeId(gradeId);
            req.setPageNo(pageNo);
            req.setPageSize(pageSize);
            OapiEduClassListResponse rsp = client.execute(req, access_token);
            System.out.println(rsp.getBody());
            return rsp;
        } catch (ApiException e) {
            e.printStackTrace();
        }
        return null;
    }

    /**
     * 年级Id查询年级信息
     * @param gradeId
     * @return
     */
    public static OapiEduGradeGetResponse getEduPeriodGrade(Long gradeId){
        try {
            String access_token = getAccessToken();
            DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/edu/grade/get");
            OapiEduGradeGetRequest req = new OapiEduGradeGetRequest();
            req.setGradeId(gradeId);
            OapiEduGradeGetResponse rsp = client.execute(req, access_token);
            System.out.println(rsp.getBody());
            return rsp;
        } catch (ApiException e) {
            e.printStackTrace();
        }
        return null;
    }

    /**
     * 学段Id查询年级列表
     * @param periodId
     * @return
     */
    public static OapiEduGradeListResponse getEduPeriodLearning(Long periodId){
        try {
            String access_token = getAccessToken();
            DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/edu/grade/list");
            OapiEduGradeListRequest req = new OapiEduGradeListRequest();
            req.setPeriodId(periodId);
            OapiEduGradeListResponse rsp = client.execute(req, access_token);
            System.out.println(rsp.getBody());
            return rsp;
        } catch (ApiException e) {
            e.printStackTrace();
        }
        return null;
    }

    /**
     * 查询学段信息
     * @param periodId
     * @return
     */
    public static OapiEduPeriodGetResponse getEduPeriodLearningText(Long periodId){
        try {
            String access_token = getAccessToken();
            DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/edu/period/get");
            OapiEduPeriodGetRequest req = new OapiEduPeriodGetRequest();
            req.setPeriodId(periodId);
            OapiEduPeriodGetResponse rsp = client.execute(req, access_token);
            System.out.println(rsp.getBody());
            return rsp;
        } catch (ApiException e) {
            e.printStackTrace();
        }
        return null;
    }

    /**
     * 查询学段列表
     * @param campusId
     * @return
     */
    public static OapiEduPeriodListResponse getEduLearningPeriod(Long campusId){
        try {
            String access_token = getAccessToken();
            DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/edu/period/list");
            OapiEduPeriodListRequest req = new OapiEduPeriodListRequest();
            req.setCampusId(campusId);
            OapiEduPeriodListResponse rsp = client.execute(req, access_token);
            System.out.println(rsp.getBody());
            return rsp;
        } catch (ApiException e) {
            e.printStackTrace();
        }
        return null;
    }

    /**
     * 查询校区信息
     * @param campusId
     * @return
     */
    public static OapiEduCampusGetResponse getSchoolText(Long campusId){

        try {
            String accessToken = getAccessToken();
            DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/edu/campus/get");
            OapiEduCampusGetRequest req = new OapiEduCampusGetRequest();
            req.setCampusId(campusId);
            OapiEduCampusGetResponse rsp = client.execute(req, accessToken);
            System.out.println(rsp.getBody());
            return rsp;
        } catch (ApiException e) {
            e.printStackTrace();
        }
        return null;

    }
    /**
     * 获取学校列表
     * @return
     */
    public static String getSchoolName(){
        try {
            String accessToken = getAccessToken();
            DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/edu/campus/list");
            OapiEduCampusListRequest req = new OapiEduCampusListRequest();
            OapiEduCampusListResponse rsp = client.execute(req, accessToken);
            System.out.println(rsp.getBody());
            String body = rsp.getBody();
            return body;
        } catch (ApiException e) {
            e.printStackTrace();
        }
        return null;
    }

    /**
     * 获取部门列表
     * @return
     */
    public static String getDepartment(){
        try {
            String accessToken = getAccessToken();
            DefaultDingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/department/list");
            OapiDepartmentListRequest request = new OapiDepartmentListRequest();
            request.setHttpMethod("GET");
            OapiDepartmentListResponse listResponse = client.execute(request, accessToken);
            String body = listResponse.getBody();
            log.info("****body****, :{}",body);
            return body;
        } catch (ApiException e) {
            e.printStackTrace();
            return null;
        }
    }

    /**
     * 创建一个部门列表
     * @return
     */
    public static OapiDepartmentCreateResponse getCreateDepartment(){
        String accessToken = getAccessToken();
        try {
            DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/department/create");
            OapiDepartmentCreateRequest request = new OapiDepartmentCreateRequest();
            request.setParentid("1");
            request.setCreateDeptGroup(true);
            request.setOrder("100");
            request.setName("部门1");
            OapiDepartmentCreateResponse response = client.execute(request,accessToken);
            Long errcode = response.getErrcode();
            System.out.println(errcode);
            String errmsg = response.getErrmsg();
            System.out.println(errmsg);
            Long id = response.getId();
            System.out.println(id);
            return response;
        } catch (ApiException e) {
            e.printStackTrace();
            return null;
        }
    }


    /**
     * 获取ACCESSTOKEN
     * @return
     */
    public static String getAccessToken() {
        DefaultDingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/gettoken");
        OapiGettokenRequest request = new OapiGettokenRequest();
        request.setAppkey(APP_KEY);
        request.setAppsecret(APP_SECRET);
        request.setHttpMethod("GET");
        try {
            OapiGettokenResponse response = client.execute(request);
            if(response.isSuccess()){
                return response.getAccessToken();
            }
        }catch (ApiException e){
            e.printStackTrace();
        }
        return "-1";
    }

    /**
     * 获取用户ID
     * @param accessToken
     * @param authCode
     * @return
     */
    public static String getUserId(String accessToken, String authCode){
        DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/user/getuserinfo");
        OapiUserGetuserinfoRequest request = new OapiUserGetuserinfoRequest();
        request.setCode(authCode);
        request.setHttpMethod("GET");
        try {
            OapiUserGetuserinfoResponse response = client.execute(request, accessToken);
            if(response.isSuccess()){
                return response.getUserid();
            }
        }catch (ApiException e){
            e.printStackTrace();
        }
        return "-1";
    }

    /**
     * 获取用户ID
     * @param authCode
     * @return
     */
    public static String getUserId(String authCode){
        return getUserId(getAccessToken(), authCode);
    }

    /**
     * 获取用户详细信息
     * @param accessToken
     * @param userId
     * @return
     */
    public static OapiUserGetResponse getUerInfo(String accessToken, String userId){
        DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/user/get");
        OapiUserGetRequest request = new OapiUserGetRequest();
        request.setUserid(userId);
        request.setHttpMethod("GET");
        try{
            return client.execute(request, accessToken);
        }catch (ApiException e){
            e.printStackTrace();
        }
        return null;
    }

    /**
     * 用钉钉id获取用户详细信息
     * @param userId
     * @return
     */
    public static OapiUserGetResponse getUerInfoById(String userId){
        String accessToken  = getAccessToken();
        return getUerInfo(accessToken,userId);
    }

    /**
     * 获取用户详细信息
     * @param authCode
     * @return
     */
    public static OapiUserGetResponse getUerInfo(String authCode){
        String accessToken = getAccessToken();
        String userId = getUserId(accessToken,authCode);
        return getUerInfo(accessToken, userId);
    }

    /**
     *  发送代办事项 （每人每天上线100）
     * @param
     * @throws Exception
     */
    public static OapiWorkrecordAddResponse sendDingAgency(String dingUserId, String bannerTitle, String url, String formTitle, String formContent){
        String accessToken  = getAccessToken();
        try{
            DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/workrecord/add");
            OapiWorkrecordAddRequest req = new OapiWorkrecordAddRequest();
            req.setUserid(dingUserId);
            req.setCreateTime(System.currentTimeMillis());
            req.setTitle(bannerTitle);
            req.setUrl(url);
            List<OapiWorkrecordAddRequest.FormItemVo> list2 = new ArrayList<OapiWorkrecordAddRequest.FormItemVo>();
            OapiWorkrecordAddRequest.FormItemVo obj3 = new OapiWorkrecordAddRequest.FormItemVo();
            obj3.setTitle(formTitle);
            obj3.setContent(formContent);
            req.setFormItemList(list2);
            return client.execute(req, accessToken);
        }catch (Exception e){
            e.printStackTrace();
        }
        return null;
    }

    /**
     *  更新代办事项
     * @param
     * @throws Exception
     */
    public static OapiWorkrecordAddResponse updateDingAgency(String dingUserId, String dingRecordId){
        String accessToken  = getAccessToken();
        try{
            DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/workrecord/update");
            OapiWorkrecordUpdateRequest req = new OapiWorkrecordUpdateRequest();
            req.setUserid(dingUserId);
            req.setRecordId(dingRecordId);
            OapiWorkrecordUpdateResponse rsp = client.execute(req, accessToken);
            System.out.println(rsp.getBody());
        }catch (Exception e){
            e.printStackTrace();
        }
        return null;
    }

    /**
     * 发送action card 普通消息
     * @throws Exception
     */
    public static OapiMessageSendToConversationResponse sendNewActionCardMsg(
            String sender, String cid, String title, String singleTitle, String singleUrl, String markDown) {
        log.info("sender=={}", sender);
        log.info("cid=={}", cid);
        String accessToken  = getAccessToken();
        try {
            DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/message/send_to_conversation");
            OapiMessageSendToConversationRequest req = new OapiMessageSendToConversationRequest();
            req.setSender(sender);
            req.setCid(cid);

            OapiMessageSendToConversationRequest.Msg msg = new OapiMessageSendToConversationRequest.Msg();

            OapiMessageSendToConversationRequest.ActionCard actionCard = new OapiMessageSendToConversationRequest.ActionCard();
            actionCard.setMarkdown(markDown);
            actionCard.setTitle(title);
            actionCard.setSingleTitle(singleTitle);
            actionCard.setSingleUrl(singleUrl);

            msg.setActionCard(actionCard);
            msg.setMsgtype("action_card");
            req.setMsg(msg);

            OapiMessageSendToConversationResponse response = client.execute(req, accessToken);
            log.info("发送action_card响应结果={}", response.getBody());
            return response;
        } catch (ApiException e) {
            e.printStackTrace();
        }
        return null;
    }

    /**
     * 发送action card 工作通知消息
     * @throws Exception
     */
    public static OapiMessageCorpconversationAsyncsendV2Response sendActionCardMsg(String dingUserId, String title, String singleTitle, String singleUrl, String markDown){
        String accessToken  = getAccessToken();
        try{
            DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/message/corpconversation/asyncsend_v2");
            OapiMessageCorpconversationAsyncsendV2Request request = new OapiMessageCorpconversationAsyncsendV2Request();
            request.setAgentId(APP_AGENTID);
            request.setToAllUser(false);
            request.setUseridList(dingUserId);
            OapiMessageCorpconversationAsyncsendV2Request.Msg msg = new OapiMessageCorpconversationAsyncsendV2Request.Msg();

            msg.setActionCard(new OapiMessageCorpconversationAsyncsendV2Request.ActionCard());
            msg.getActionCard().setTitle(title);
            msg.getActionCard().setSingleTitle(singleTitle);
            msg.getActionCard().setSingleUrl(singleUrl);
            msg.getActionCard().setMarkdown(markDown);
            msg.setMsgtype("action_card");
            request.setMsg(msg);

            return client.execute(request,accessToken);
        }catch (Exception e){
            e.printStackTrace();
        }
        return null;
    }

    /**
     * 发送markDown消息
     * @throws Exception
     */
    public static OapiMessageCorpconversationAsyncsendV2Response sendMarkDownMsg(String dingUserId, String title, String markDownContent){
        String accessToken  = getAccessToken();
        try{
            DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/message/corpconversation/asyncsend_v2");
            OapiMessageCorpconversationAsyncsendV2Request request = new OapiMessageCorpconversationAsyncsendV2Request();
            request.setAgentId(APP_AGENTID);
            request.setToAllUser(false);
            request.setUseridList(dingUserId);
            OapiMessageCorpconversationAsyncsendV2Request.Msg msg = new OapiMessageCorpconversationAsyncsendV2Request.Msg();

            msg.setMsgtype("markdown");
            msg.setMarkdown(new OapiMessageCorpconversationAsyncsendV2Request.Markdown());
            msg.getMarkdown().setText(markDownContent);
            msg.getMarkdown().setTitle(title);
            request.setMsg(msg);
            return client.execute(request,accessToken);
        }catch (Exception e){
            e.printStackTrace();
        }
        return null;
    }


    /**
     * 发送链接消息消息
     * @throws Exception
     */
    public static OapiMessageCorpconversationAsyncsendV2Response sendMsgUrl(String dingUserId, String picUrl, String title, String text, String url){
        String accessToken  = getAccessToken();
        try{
            DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/message/corpconversation/asyncsend_v2");
            OapiMessageCorpconversationAsyncsendV2Request request = new OapiMessageCorpconversationAsyncsendV2Request();
            request.setAgentId(APP_AGENTID);
            request.setToAllUser(false);
            request.setUseridList(dingUserId);
            OapiMessageCorpconversationAsyncsendV2Request.Msg msg = new OapiMessageCorpconversationAsyncsendV2Request.Msg();

            msg.setMsgtype("link");
            msg.setLink(new OapiMessageCorpconversationAsyncsendV2Request.Link());
            msg.getLink().setTitle(title);
            msg.getLink().setText(text);
            msg.getLink().setMessageUrl(url);
            msg.getLink().setPicUrl(picUrl);
            request.setMsg(msg);

            return client.execute(request,accessToken);
        }catch (Exception e){
            e.printStackTrace();
        }
        return null;
    }

    /**
     * 添加钉钉用户
     * @throws Exception
     */
    public static OapiUserCreateResponse createDingUser(String name, String mobile, Long dingDeptId){
        String accessToken  = getAccessToken();

        try{
            DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/user/create");
            OapiUserCreateRequest request = new OapiUserCreateRequest();
            request.setMobile(mobile);
            request.setName(name);

            // 需要用字符串， "[100,200]" 这种格式
            List<Long> departments = new ArrayList<Long>();
            departments.add(dingDeptId);
            request.setDepartment(JSON.toJSONString(departments));
            return client.execute(request, accessToken);
        }catch (Exception e){
            e.printStackTrace();
        }
        return null;
    }

    /**
     * 更新钉钉用户
     * @throws Exception
     */
    public static OapiUserUpdateResponse updateDingUser(String dingUserId, String name, List departments){
        String accessToken  = getAccessToken();
        try{
            DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/user/update");
            OapiUserUpdateRequest request = new OapiUserUpdateRequest();
            request.setUserid(dingUserId);
            request.setName(name);

            // 需要用字符串， "[100,200]" 这种格式
            /*List<Long> departments = new ArrayList<Long>();
            departments.add(dingDeptId);*/
            request.setDepartment(departments);

            return client.execute(request, accessToken);
        }catch (Exception e){
            e.printStackTrace();
        }
        return null;
    }

    /**
     * 获取部门用户详情
     * @param deptId
     * @param offset
     * @param size  最大100
     * @throws Exception
     */
    public static OapiUserListbypageResponse getDeptDetails(Long deptId, Long offset, Long size){
        String accessToken = getAccessToken();
        try {
            DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/user/listbypage");
            OapiUserListbypageRequest request = new OapiUserListbypageRequest();
            request.setDepartmentId(deptId);
            request.setOffset(offset);
            request.setSize(size);
            request.setOrder("entry_desc");
            request.setHttpMethod("GET");
            return client.execute(request,accessToken);
        }catch (Exception e){
            e.printStackTrace();
        }
        return null;
    }

    /**
     * 获取
     */

    /**
     * 获取JSTicket, 用于js的签名计算
     * @return
     * @throws ApiException
     */
    public static String getJsapiTicket(){
        String accessToken = getAccessToken();
        try{
            DefaultDingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/get_jsapi_ticket");
            OapiGetJsapiTicketRequest req = new OapiGetJsapiTicketRequest();
            req.setTopHttpMethod("GET");
            OapiGetJsapiTicketResponse execute = client.execute(req, accessToken);
            return execute.getTicket();
        }catch (Exception e){
            e.printStackTrace();
        }
        return null;
    }

    //得到随机字符串
    private static String create_nonce_str() {
        return UUID.randomUUID().toString();
    }

    //得到时间戳
    private static String create_timestamp() {
        return Long.toString(System.currentTimeMillis() / 1000);
    }


    /**
     * 计算sign
     * @param ticket
     * @param nonceStr
     * @param timeStamp
     * @param url
     * @return
     */
    private static String sign(String ticket, String nonceStr, String timeStamp, String url) {
        String plain = "jsapi_ticket=" + ticket + "&noncestr=" + nonceStr + "&timestamp=" + timeStamp
                + "&url=" + url;
        System.out.println(plain);
        return SecurityUtil.sha1(plain);
    }

    public static Map getSin(HttpServletRequest request){
        Map ret = new HashMap();
        //得到请求URL
        String urlString = request.getRequestURL().toString();
        String queryString = request.getQueryString();

        String queryStringEncode = null;
        String url;
        if (queryString != null) {
            queryStringEncode = URLDecoder.decode(queryString);
            url = urlString + "?" + queryStringEncode;
        } else {
            url = urlString;
        }
        int length=url.indexOf("#");
        String uri = url;
        if(length > 0){
            uri=url.substring(0,length);//当前网页的URL，不包含#及其后面部分
        }
        String signedUrl = url;

        String jsapi_ticket= getJsapiTicket();
        System.out.println("JSAPI_TICKET = " + jsapi_ticket);
        String nonce_str = create_nonce_str();
        String timestamp = create_timestamp();
        String signature = sign(jsapi_ticket,nonce_str,timestamp,signedUrl);
        ret.put("AGENTID", APP_AGENTID);
        ret.put("corpId", APP_KEY);
        ret.put("url", signedUrl);
        ret.put("jsapi_ticket", jsapi_ticket);
        ret.put("nonceStr", nonce_str);
        ret.put("timestamp", timestamp);
        ret.put("signature", signature);
        return ret;
    }

    public static Map getSin(String url){
        Map ret = new HashMap();
        //得到请求URL
        String jsapi_ticket= getJsapiTicket();
        System.out.println("JSAPI_TICKET = " + jsapi_ticket);
        String nonce_str = create_nonce_str();
        String timestamp = create_timestamp();
        String signature = sign(jsapi_ticket,nonce_str,timestamp,url);
        ret.put("AGENTID", APP_AGENTID);
        ret.put("corpId", APP_KEY);
        ret.put("url", url);
        ret.put("jsapi_ticket", jsapi_ticket);
        ret.put("nonceStr", nonce_str);
        ret.put("timestamp", timestamp);
        ret.put("signature", signature);
        return ret;
    }



    public static void main(String[] args) throws Exception{
        String accessToken = getAccessToken();
        System.out.println(accessToken);

        //getDepartment();

//        sendActionCardMsg();
//        String accessToken  = getAccessToken();
//        DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/message/corpconversation/asyncsend_v2");
//
//        OapiMessageCorpconversationAsyncsendV2Request request = new OapiMessageCorpconversationAsyncsendV2Request();
//        request.setUseridList("15525475557359430,1909236266772329");
//        request.setAgentId(245073763L);
//        request.setToAllUser(false);
//
//        OapiMessageCorpconversationAsyncsendV2Request.Msg msg = new OapiMessageCorpconversationAsyncsendV2Request.Msg();
//        msg.setMsgtype("text");
//        msg.setText(new OapiMessageCorpconversationAsyncsendV2Request.Text());
//        msg.getText().setContent("**haha1111hah** \n sfddsvfdgfdg1111112222112222");
//        request.setMsg(msg);

//        msg.setMsgtype("image");
//        msg.setImage(new OapiMessageCorpconversationAsyncsendV2Request.Image());
//        msg.getImage().setMediaId("@lADOdvRYes0CbM0CbA");
//        request.setMsg(msg);

//        msg.setMsgtype("file");
//        msg.setFile(new OapiMessageCorpconversationAsyncsendV2Request.File());
//        msg.getFile().setMediaId("@lADOdvRYes0CbM0CbA");
//        request.setMsg(msg);

//        msg.setMsgtype("link");
//        msg.setLink(new OapiMessageCorpconversationAsyncsendV2Request.Link());
//        msg.getLink().setTitle("test");
//        msg.getLink().setText("test");
//        msg.getLink().setMessageUrl("test");
//        msg.getLink().setPicUrl("test");
//        request.setMsg(msg);

//        msg.setMsgtype("markdown");
//        msg.setMarkdown(new OapiMessageCorpconversationAsyncsendV2Request.Markdown());
//        msg.getMarkdown().setText("##### tex213t");
//        msg.getMarkdown().setTitle("### 32132132132131");
//        request.setMsg(msg);

//        msg.setOa(new OapiMessageCorpconversationAsyncsendV2Request.OA());
//        msg.getOa().setHead(new OapiMessageCorpconversationAsyncsendV2Request.Head());
//        msg.getOa().getHead().setText("head");
//        msg.getOa().setBody(new OapiMessageCorpconversationAsyncsendV2Request.Body());
//        msg.getOa().getBody().setContent("xxx");
//        msg.setMsgtype("oa");
//        request.setMsg(msg);

//        msg.setActionCard(new OapiMessageCorpconversationAsyncsendV2Request.ActionCard());
//        msg.getActionCard().setTitle("哈哈哈哈2");
//        msg.getActionCard().setMarkdown("**haha1hah** \n sfddsvfdgfdg111111112222");
//        List<OapiMessageCorpconversationAsyncsendV2Request.BtnJsonList> btnJsonLists = new ArrayList<>();
//        OapiMessageCorpconversationAsyncsendV2Request.BtnJsonList bt1 = new OapiMessageCorpconversationAsyncsendV2Request.BtnJsonList();
//        bt1.setTitle("aaaaa");
//        bt1.setActionUrl("http://www.baidu.com");
//        OapiMessageCorpconversationAsyncsendV2Request.BtnJsonList bt2 = new OapiMessageCorpconversationAsyncsendV2Request.BtnJsonList();
//        bt2.setTitle("bbb");
//        bt2.setActionUrl("http://www.163.com");
//        btnJsonLists.add(bt1);
//        btnJsonLists.add(bt2);
//        msg.getActionCard().setBtnJsonList(btnJsonLists);
//        msg.getActionCard().setBtnOrientation("1");
//        msg.setMsgtype("action_card");
//        request.setMsg(msg);

//        OapiMessageCorpconversationAsyncsendV2Response response = client.execute(request,accessToken);
//        sendDingAgency("1909236266772329","杨家1傻子啊","http://jcs.tata.com.cn/","杨家1傻子啊","杨家1傻子啊");
//        String accessToken  = getAccessToken();
//        System.out.println(accessToken);
//        //        System.out.println("accessToken = " + accessToken);
////        String userId = getUserId(accessToken, "feeb9fa4b0773a46a2c9b9bd5f7b4177");
////        System.out.println("userId = " + userId);
//        OapiUserGetResponse r = getUerInfo(accessToken, "1909236266772329");
//        System.out.println(r.getName());
//
//        //推送代办Test
//        DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/workrecord/add");
//        OapiWorkrecordAddRequest req = new OapiWorkrecordAddRequest();
//        req.setUserid("1909236266772329");
//        req.setCreateTime(new Date().getTime());
//        req.setTitle("安装代办");
//        req.setUrl("http://jcs.tata.com.cn/css/dingding/index.do");
//        List<OapiWorkrecordAddRequest.FormItemVo> list2 = new ArrayList<OapiWorkrecordAddRequest.FormItemVo>();
//        OapiWorkrecordAddRequest.FormItemVo obj3 = new OapiWorkrecordAddRequest.FormItemVo();
//        list2.add(obj3);
//        obj3.setTitle("安装11111");
//        obj3.setContent("安装22222");
//        req.setFormItemList(list2);
//        OapiWorkrecordAddResponse rsp = client.execute(req, accessToken);
//        System.out.println(rsp.getBody());

        //推送Link消息 并打开E应用
//        DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/message/corpconversation/asyncsend_v2");
//        OapiMessageCorpconversationAsyncsendV2Request request = new OapiMessageCorpconversationAsyncsendV2Request();
//        request.setUseridList("1909236266772329");
//        request.setAgentId(245073763L);
//        request.setToAllUser(false);
//        OapiMessageCorpconversationAsyncsendV2Request.Msg msg = new OapiMessageCorpconversationAsyncsendV2Request.Msg();
//        msg.setMsgtype("link");
//        msg.setLink(new OapiMessageCorpconversationAsyncsendV2Request.Link());
//        msg.getLink().setTitle("test111");
//        msg.getLink().setText("test2222");
//        msg.getLink().setMessageUrl("http://jcs.tata.com.cn/css/dingding/index.do"); //  (1)eapp:// 打开E应用 (2)eapp://pages/index/index?query 打开某个指定页面
//        msg.getLink().setPicUrl("test");
//        request.setMsg(msg);
//
//
////        msg.setMsgtype("text");
////        msg.setText(new OapiMessageCorpconversationAsyncsendV2Request.Text());
////        msg.getText().setContent("test123");
////        request.setMsg(msg);
//        OapiMessageCorpconversationAsyncsendV2Response response = client.execute(request,accessToken);

//        sendDingAgency("1909236266772329","1","http://www.baidu.com","2","3");

//        String accessToken  = getAccessToken();
//        DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/department/list");
//        OapiDepartmentListRequest request = new OapiDepartmentListRequest();
//        request.setId("88735037");
//        request.setHttpMethod("GET");
//        OapiDepartmentListResponse response = client.execute(request, accessToken);
//        CssDingUtil.sendMarkDownMsg("1909236266772329,","安装通知1", "# 安装通知 \n  请于 " + "**2019-05-02**" + "为  \n  " + "**杨傻子**"+"客户准时进行上门安装，  \n   地址："
//                + "杨家庄2250号" + "  \n  电话："+ "6663336611116666666666" + "  \n  单号："+ "S250360360");
//        sendMarkDownMsg("15525475557359430","aaaaaa", "bbbbb");

//        OapiUserCreateResponse response = CssDingUtil.createDingUser("庄园","15810693770",118002941L);
//        System.out.println("aaaaaa");
//        OapiUserUpdateResponse response =  CssDingUtil.updateDingUser("2231544203772329","庄园1",118002941L);
//        OapiUserListbypageResponse response = CssDingUtil.getDeptDetails(118002941L,0L, 100L);
//        System.out.println("aaaaaa");
    }
    /**
     * 根据用户Id查询用户角色
     * @param id
     * @return
     */
    public static OapiDepartmentGetResponse getDepartment(String id){
        try {
            String access_token = getAccessToken();
            DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/department/get");
            OapiDepartmentGetRequest request = new OapiDepartmentGetRequest();
            request.setId(id);
            request.setHttpMethod("GET");
            OapiDepartmentGetResponse response = client.execute(request, access_token);
            return response;
        } catch (ApiException e) {
            e.printStackTrace();
        }
        return null;
    }
    /**
     * 根据用户userId查询指定用户的所有上级父部门路径
     * @param userId
     * @return
     */
    public static OapiDepartmentListParentDeptsResponse  getListParentDept(String userId){
        try {
            String access_token = getAccessToken();
            DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/department/list_parent_depts");
            OapiDepartmentListParentDeptsRequest request = new OapiDepartmentListParentDeptsRequest();
            request.setUserId(userId);
            request.setHttpMethod("GET");
            OapiDepartmentListParentDeptsResponse response = client.execute(request, access_token);
            return response;
        } catch (ApiException e) {
            e.printStackTrace();
        }
        return null;
    }
    /**
     * 根据部门的id查询部门的所有上级父部门路径
     * @param id
     * @return
     */
    public static OapiDepartmentListParentDeptsByDeptResponse  getListParentByDept(String id){
        try {
            String access_token = getAccessToken();
            DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/department/list_parent_depts_by_dept");
            OapiDepartmentListParentDeptsByDeptRequest request = new OapiDepartmentListParentDeptsByDeptRequest();
            request.setId(id);
            request.setHttpMethod("GET");
            OapiDepartmentListParentDeptsByDeptResponse response = client.execute(request, access_token);
            return response;
        } catch (ApiException e) {
            e.printStackTrace();
        }
        return null;
    }
    /**
     * 查看班级下某个监护人的人员关系列表。
     * @param classId ,fromUserId
     * @return
     */
    public static OapiEduUserRelationGetResponse   getRelation(Long classId,String fromUserId){
        try {
            String access_token = getAccessToken();
            DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/edu/user/relation/get");
            OapiEduUserRelationGetRequest req = new OapiEduUserRelationGetRequest();
            req.setClassId(classId);
            req.setFromUserid(fromUserId);
            OapiEduUserRelationGetResponse rsp = client.execute(req, access_token);
            System.out.println(rsp.getBody());
            return rsp;
        } catch (ApiException e) {
            e.printStackTrace();
        }
        return null;
    }

    /**
     * 根据手机号获取员工UserID
     * @param mobile
     * @return
     */
    public static String getDingUserId(String mobile) {
        try {
            DingTalkClient client =
                    new DefaultDingTalkClient("https://oapi.dingtalk.com/user/get_by_mobile");
            OapiUserGetByMobileRequest req = new OapiUserGetByMobileRequest();
            req.setMobile(mobile);
            req.setHttpMethod("GET");
            OapiUserGetByMobileResponse rsp = client.execute(req, getAccessToken());
            log.info("响应结果={}", rsp.getBody());
            JSONObject jsonObject = JSONObject.parseObject(rsp.getBody());
            return (String) jsonObject.get("userid");
        } catch (ApiException e) {
            e.printStackTrace();
        }
        return new String();
    }

    /**
     * 用钉钉authCode获取用户详细信息
     * @param authCode
     * @return
     */
    public static UserVo getUerInfoDetail(String authCode) throws ApiException {
        UserVo UserVo=new UserVo();
        String accessToken  = getAccessToken();
        //根据authCode换取用户id
        String userId = getUserId(accessToken,authCode);
        //根据用户userId获取用户详情
        return getUserVo(userId, UserVo, accessToken);
    }
    /**
     * 用钉钉authCode获取用户详细信息
     * @param userId
     * @return
     */
    public static UserVo getUerInfoDetailByUserId(String userId) throws ApiException {
        UserVo UserVo=new UserVo();
        String accessToken  = getAccessToken();

//        //根据authCode换取用户id
//        String userId = getUserId(accessToken,authCode);
        //根据用户userId获取用户详情
        return getUserVo(userId, UserVo, accessToken);
    }

    private static UserVo getUserVo(String userId, UserVo userVo, String accessToken) throws ApiException {

        //获取学校信息
        DingTalkClient clientCampus = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/edu/campus/list");
        OapiEduCampusListRequest reqCampus = new OapiEduCampusListRequest();
        OapiEduCampusListResponse rspCampus = clientCampus.execute(reqCampus, accessToken);
        log.info("获取学校信息");
        log.info( JSON.toJSONString(rspCampus));
        if(rspCampus.isSuccess()){
            userVo.setSchoolName(rspCampus.getResult().get(0).getName());
            userVo.setSchoolCode(rspCampus.getResult().get(0).getCampusId().toString());
        }

        //查询学信息
        DingTalkClient clientPeriod = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/edu/period/list");
        OapiEduPeriodListRequest reqPeriod = new OapiEduPeriodListRequest();
        reqPeriod.setCampusId(Long.parseLong(userVo.getSchoolCode()));
        OapiEduPeriodListResponse rspPeriod = clientPeriod.execute(reqPeriod, accessToken);
        System.out.println(rspPeriod.getBody());
        log.info("查询学信息");
        log.info( JSON.toJSONString(rspPeriod));
        if(rspPeriod.isSuccess()){
            if(null!=rspPeriod.getResult()){
                userVo.setPeriodId(rspPeriod.getResult().get(0).getPeriodId().toString());
            }

        }
        DingTalkClient clientUser = new DefaultDingTalkClient("https://oapi.dingtalk.com/user/get");
        OapiUserGetRequest request = new OapiUserGetRequest();
        request.setUserid(userId);
        request.setHttpMethod("GET");
        OapiUserGetResponse response = clientUser.execute(request, accessToken);
        userVo.setUserId(userId);
        userVo.setUserName(response.getName());
        log.info("获取个人信息");
        log.info( JSON.toJSONString(response));
        if(response.isSuccess()){
            //有设角色取角色
            if(null!=response.getRoles()){
                userVo.setRoles(response.getRoles().get(0).getName());
                //没角色取部门
            }else {
                DingTalkClient clientDepart = new DefaultDingTalkClient("https://oapi.dingtalk.com/department/get");
                OapiDepartmentGetRequest requestDepart = new OapiDepartmentGetRequest();
                requestDepart.setId(response.getDepartment().get(0).toString());
                requestDepart.setHttpMethod("GET");
                OapiDepartmentGetResponse responseDepart = clientDepart.execute(requestDepart, accessToken);
                log.info("获取部门明细");
                log.info(JSON.toJSONString(responseDepart));
                if (responseDepart.isSuccess()) {
                    userVo.setRoles(responseDepart.getName());
                }
                if ("家长".equals(responseDepart.getName()) || "老师".equals(responseDepart.getName())) {
                //查询所在部门班级
                DingTalkClient clientDept = new DefaultDingTalkClient("https://oapi.dingtalk.com/department/list_parent_depts_by_dept");
                OapiDepartmentListParentDeptsByDeptRequest requestDept = new OapiDepartmentListParentDeptsByDeptRequest();
                requestDept.setId(response.getDepartment().get(0).toString());
                requestDept.setHttpMethod("GET");
                OapiDepartmentListParentDeptsByDeptResponse responseDept = clientDept.execute(requestDept, accessToken);
                log.info("获取上级部门");
                log.info(JSON.toJSONString(responseDept));
                if (responseDepart.isSuccess()) {
                    userVo.setClassCode(responseDept.getParentIds().get(1).toString());
                    userVo.setGrade(responseDept.getParentIds().get(2).toString());
                    //获取年级信息
                    DingTalkClient clientGrade = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/edu/grade/get");
                    OapiEduGradeGetRequest reqGrade = new OapiEduGradeGetRequest();
                    reqGrade.setGradeId(responseDept.getParentIds().get(2));
                    OapiEduGradeGetResponse rspGrade = clientGrade.execute(reqGrade, accessToken);
                    log.info("获取年级信息");
                    log.info(JSON.toJSONString(rspGrade.getResult()));
                    System.out.println(rspGrade.getBody());
                    if (rspGrade.isSuccess()) {
                        userVo.setGradeName(rspGrade.getResult().getName());
                    }
                    //获取年班级信息
                    DingTalkClient clientClass = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/edu/class/get");
                    OapiEduClassGetRequest reqClass = new OapiEduClassGetRequest();
                    reqClass.setClassId(responseDept.getParentIds().get(1));
                    OapiEduClassGetResponse rspClass = clientClass.execute(reqClass, accessToken);
                    System.out.println(rspClass.getBody());
                    log.info("获取年班级信息");
                    log.info(JSON.toJSONString(rspClass.getResult()));
                    System.out.println(rspClass.getBody());
                    if (rspClass.isSuccess()) {
                        userVo.setClassName(rspClass.getResult().getName());
                    }
                }


                //根据班级查询学生信息
                if ("家长".equals(userVo.getRoles())) {
                    DingTalkClient clientRelation = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/edu/user/relation/get");
                    OapiEduUserRelationGetRequest reqRelation = new OapiEduUserRelationGetRequest();
                    reqRelation.setClassId(responseDept.getParentIds().get(1));
                    reqRelation.setFromUserid(userId);
                    OapiEduUserRelationGetResponse rspRelation = clientRelation.execute(reqRelation, accessToken);
                    log.info("获取学生关系");
                    log.info(JSON.toJSONString(rspRelation.getResult()));
                    if (rspRelation.isSuccess()) {
                        userVo.setStudentUserId(rspRelation.getResult().getRelations().get(0).getToUserid());
                        //查询学生信息
                        DingTalkClient clientStudent = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/edu/student/get");
                        OapiEduStudentGetRequest reqStudent = new OapiEduStudentGetRequest();
                        reqStudent.setClassId(responseDept.getParentIds().get(1));
                        reqStudent.setStudentUserid(rspRelation.getResult().getRelations().get(0).getToUserid());
                        OapiEduStudentGetResponse rspStudent = clientStudent.execute(reqStudent, accessToken);
                        log.info("获取学生关系");
                        log.info(JSON.toJSONString(rspStudent.getResult()));
                        if (rspStudent.isSuccess()) {
                            userVo.setStudentName(rspStudent.getResult().getName());
                            userVo.setStudentNo(rspStudent.getResult().getStudentNo());
                            userVo.setGrade(rspStudent.getResult().getGradeId().toString());
                        }


                    }
                }
            }

            }
        }

        return userVo;
    }
    /**
     * 用H5获取学校信息
     * @param
     * @return
     */
    public static UserVo getSchoolDetail() throws ApiException {
        UserVo userVo=new UserVo();
        String accessToken  = getAccessToken();
        //获取学校信息
        DingTalkClient clientCampus = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/edu/campus/list");
        OapiEduCampusListRequest reqCampus = new OapiEduCampusListRequest();
        OapiEduCampusListResponse rspCampus = clientCampus.execute(reqCampus, accessToken);
        if(rspCampus.isSuccess()){
            userVo.setSchoolName(rspCampus.getResult().get(0).getName());
            userVo.setSchoolCode(rspCampus.getResult().get(0).getCampusId().toString());
        }

        //查询学信息
        DingTalkClient clientPeriod = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/edu/period/list");
        OapiEduPeriodListRequest reqPeriod = new OapiEduPeriodListRequest();
        reqPeriod.setCampusId(Long.parseLong(userVo.getSchoolCode()));
        OapiEduPeriodListResponse rspPeriod = clientPeriod.execute(reqPeriod, accessToken);
        System.out.println(rspPeriod.getBody());
        if(rspPeriod.isSuccess()){
            if(null!=rspPeriod.getResult()){
                userVo.setPeriodId(rspPeriod.getResult().get(0).getPeriodId().toString());
            }

        }
        return userVo;
    }

    /**
     * 测试查看个人信息
     * @param userId
     * @return
     */
    public static OapiUserGetResponse   getUserIdsList(String userId){
        try {
            String access_token = getAccessToken();
            DingTalkClient clientUser = new DefaultDingTalkClient("https://oapi.dingtalk.com/user/get");
            OapiUserGetRequest request = new OapiUserGetRequest();
            request.setUserid(userId);
            request.setHttpMethod("GET");
            OapiUserGetResponse response = clientUser.execute(request, access_token);
            return response;
        } catch (ApiException e) {
            e.printStackTrace();
        }
        return null;
    }


    /**
     * 根据年级Id查询所有班级列表
     * @param gradeId
     * @return
     */
    public static List<OapiEduClassListResponse.ClassResponse> getEduPeriodClassAll(Long gradeId){
        try {
            String access_token = getAccessToken();
            List<OapiEduClassListResponse.ClassResponse>  getEduPeriodClassAll=new ArrayList<>();
            for(int i=1;i<=100;i++){
                DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/edu/class/list");
                OapiEduClassListRequest req = new OapiEduClassListRequest();
                req.setGradeId(gradeId);
                req.setPageNo(Long.valueOf(i));
                req.setPageSize(10L);
                OapiEduClassListResponse rsp = client.execute(req, access_token);
                if(null!=rsp.getResult()&&rsp.getResult().getList().size()>0){
                    if(null!=rsp.getResult().getList()){
                        getEduPeriodClassAll.addAll(rsp.getResult().getList());
                    }
                }else{
                    break;
                }
                System.out.println(rsp.getBody());
            }

            return getEduPeriodClassAll;
        } catch (ApiException e) {
            e.printStackTrace();
        }
        return null;
    }



    /**
     * 根据班级id查询学生列表
     * @param classId
     * @return
     */
    public static List<OapiEduStudentListResponse.StudentRespone> getStudentListAll(Long classId){
        try {
            String access_token = getAccessToken();
            List<OapiEduStudentListResponse.StudentRespone>  getStudentListAll=new ArrayList<>();
            for(int i=1;i<=100;i++){
                DingTalkClient client = new DefaultDingTalkClient("https://oapi.dingtalk.com/topapi/edu/student/list");
                OapiEduStudentListRequest req = new OapiEduStudentListRequest();
                req.setClassId(classId);
                req.setPageNo(Long.valueOf(i));
                req.setPageSize(10L);
                OapiEduStudentListResponse rsp = client.execute(req, access_token);
                if(null!=rsp.getResult()){
                    if(null!=rsp.getResult().getList()){
                        getStudentListAll.addAll(rsp.getResult().getList());
                    }
                }else{
                    break;
                }
            }
            return getStudentListAll;
        } catch (ApiException e) {
            e.printStackTrace();
        }
        return null;
    }
}
